#include "ppeex02.header.cxx"
void ppeex02_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_emep";
    subprocess[2] = "uu~_emep";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 2 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_emep";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emep";
  subprocess[2] = "uu~_emep";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emep";
  subprocess[2] = "uu~_emep";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepd";
  subprocess[2] = "gu_emepu";
  subprocess[3] = "gd~_emepd~";
  subprocess[4] = "gu~_emepu~";
  subprocess[5] = "dd~_emepg";
  subprocess[6] = "uu~_emepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepd";
  subprocess[2] = "gu_emepu";
  subprocess[3] = "gd~_emepd~";
  subprocess[4] = "gu~_emepu~";
  subprocess[5] = "dd~_emepg";
  subprocess[6] = "uu~_emepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepd";
  subprocess[2] = "gu_emepu";
  subprocess[3] = "gd~_emepd~";
  subprocess[4] = "gu~_emepu~";
  subprocess[5] = "dd~_emepg";
  subprocess[6] = "uu~_emepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeex02_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeex02_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_emepdd~";
  subprocess[2] = "gg_emepuu~";
  subprocess[3] = "gd_emepgd";
  subprocess[4] = "gu_emepgu";
  subprocess[5] = "gd~_emepgd~";
  subprocess[6] = "gu~_emepgu~";
  subprocess[7] = "dd_emepdd";
  subprocess[8] = "du_emepdu";
  subprocess[9] = "ds_emepds";
  subprocess[10] = "dc_emepdc";
  subprocess[11] = "dd~_emepgg";
  subprocess[12] = "dd~_emepdd~";
  subprocess[13] = "dd~_emepuu~";
  subprocess[14] = "dd~_emepss~";
  subprocess[15] = "dd~_emepcc~";
  subprocess[16] = "du~_emepdu~";
  subprocess[17] = "ds~_emepds~";
  subprocess[18] = "dc~_emepdc~";
  subprocess[19] = "uu_emepuu";
  subprocess[20] = "uc_emepuc";
  subprocess[21] = "ud~_emepud~";
  subprocess[22] = "uu~_emepgg";
  subprocess[23] = "uu~_emepdd~";
  subprocess[24] = "uu~_emepuu~";
  subprocess[25] = "uu~_emepss~";
  subprocess[26] = "uu~_emepcc~";
  subprocess[27] = "us~_emepus~";
  subprocess[28] = "uc~_emepuc~";
  subprocess[29] = "d~d~_emepd~d~";
  subprocess[30] = "d~u~_emepd~u~";
  subprocess[31] = "d~s~_emepd~s~";
  subprocess[32] = "d~c~_emepd~c~";
  subprocess[33] = "u~u~_emepu~u~";
  subprocess[34] = "u~c~_emepu~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
