#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppaa02/header/ppaa02.phasespace.h"
void ppaa02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppaa02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppaa02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppaa02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 10;}
  else if (psi_no_map[no_ps] == 2){n_channel = 6;}
  else if (psi_no_map[no_ps] == 3){n_channel = 6;}
  else if (psi_no_map[no_ps] == 4){n_channel = 6;}
  else if (psi_no_map[no_ps] == 5){n_channel = 6;}
  else if (psi_no_map[no_ps] == 6){n_channel = 6;}
  else if (psi_no_map[no_ps] == 7){n_channel = 6;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaa02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppaa02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaa02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppaa02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppaa02_ax_psp_120_gd_aad(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppaa02_ax_psp_120_gu_aau(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppaa02_ax_psp_120_gdx_aadx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppaa02_ax_psp_120_gux_aaux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppaa02_ax_psp_120_ddx_aag(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppaa02_ax_psp_120_uux_aag(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
