#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexex04/header/ppeeexex04.phasespace.h"
void ppeeexex04_ax_psp_240_gg_ememepep(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexex04_ax_psp_240_gg_ememepep");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(12);
  psi_needed_v_smin[no_ps].resize(12);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 33);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   4,    5,    6,    7}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 33);
  int needed_v_smin_4[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13,   14,   15}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 33);
  int needed_v_smin_7[] = {  16,   17,   18,   19}; //   4
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {  20,   21,   22,   23}; //   4
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 33);
  int needed_v_smin_10[] = {  24,   25,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  28,   29,   30,   31}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);

  psi_v_smax[no_ps].resize(12);
  psi_needed_v_smax[no_ps].resize(12);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57}; //  25
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 25);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 8);
  int needed_v_smax_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65}; //  25
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 25);
  int needed_v_smax_4[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 8);
  int needed_v_smax_5[] = {  16,   17,   18,   19,   20,   21,   22,   23,   66,   67,   68,   69,   70,   71,   72,   73}; //  16
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 8);
  int needed_v_smax_7[] = {  24,   25,   26,   27,   28,   29,   30,   31,   74,   75,   76,   77,   78,   79,   80,   81}; //  16
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 16);
  int needed_v_smax_8[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57}; //  17
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 17);
  int needed_v_smax_9[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65}; //  17
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 17);
  int needed_v_smax_10[] = {  66,   67,   68,   69,   70,   71,   72,   73}; //   8
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 8);
  int needed_v_smax_11[] = {  74,   75,   76,   77,   78,   79,   80,   81}; //   8
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(24);
  psi_needed_g_p[no_ps].resize(24);
  int needed_g_p_0[] = {   0,    1,    4,    5,   32,   33,   34,   35,   50,   51,   52,   53}; //  12
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 12);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   2,    3,    6,    7,   36,   37,   38,   39,   40,   54,   55,   56,   57}; //  13
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 13);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_3[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   8,    9,   12,   13,   41,   42,   43,   44,   58,   59,   60,   61}; //  12
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 12);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax1");
  int needed_g_p_6[] = {  10,   11,   14,   15,   45,   46,   47,   48,   49,   62,   63,   64,   65}; //  13
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 13);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_7[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_8[] = {  16,   17,   20,   21,   66,   67,   68,   69}; //   8
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_9[] = {  16,   17,   18,   19}; //   4
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 4);
  psi_container_IS_name.push_back("propagator_0_smin7_smax6");
  int needed_g_p_10[] = {  18,   19,   22,   23,   70,   71,   72,   73}; //   8
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 8);
  psi_container_IS_name.push_back("propagator_23_smin6_smax5");
  int needed_g_p_11[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_0_smin8_smax2");
  int needed_g_p_12[] = {  24,   25,   28,   29,   74,   75,   76,   77}; //   8
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 8);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_13[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax6");
  int needed_g_p_14[] = {  26,   27,   30,   31,   78,   79,   80,   81}; //   8
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 8);
  psi_container_IS_name.push_back("propagator_23_smin9_smax7");
  int needed_g_p_15[] = {  28,   29,   30,   31}; //   4
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax4");
  int needed_g_p_16[] = {  32,   33,   36,   37,   50,   51,   54,   55}; //   8
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 8);
  psi_container_IS_name.push_back("propagator_0_smin9_smax8");
  int needed_g_p_17[] = {  34,   35,   38,   39,   40,   52,   53,   56,   57}; //   9
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 9);
  psi_container_IS_name.push_back("propagator_23_smin9_smax8");
  int needed_g_p_18[] = {  41,   42,   45,   46,   58,   59,   62,   63}; //   8
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax9");
  int needed_g_p_19[] = {  43,   44,   47,   48,   49,   60,   61,   64,   65}; //   9
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 9);
  psi_container_IS_name.push_back("propagator_23_smin6_smax9");
  int needed_g_p_20[] = {  66,   67,   70,   71}; //   4
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax10");
  int needed_g_p_21[] = {  68,   69,   72,   73}; //   4
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 4);
  psi_container_IS_name.push_back("propagator_23_smin3_smax10");
  int needed_g_p_22[] = {  74,   75,   78,   79}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax11");
  int needed_g_p_23[] = {  76,   77,   80,   81}; //   4
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax11");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(8);
  psi_needed_g_t[no_ps].resize(8);
  int needed_g_t_0[] = {  50,   52,   54,   56}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_24");
  int needed_g_t_1[] = {  51,   53,   55,   57}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__36_24");
  int needed_g_t_2[] = {  58,   60,   62,   64}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_40");
  int needed_g_t_3[] = {  59,   61,   63,   65}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__20_40");
  int needed_g_t_4[] = {  66,   68,   70,   72}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_20");
  int needed_g_t_5[] = {  67,   69,   71,   73}; //   4
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__40_20");
  int needed_g_t_6[] = {  74,   76,   78,   80}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_36");
  int needed_g_t_7[] = {  75,   77,   79,   81}; //   4
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__24_36");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(18);
  psi_needed_g_d[no_ps].resize(18);
  int needed_g_d_0[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 33);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_6[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 33);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_7[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_8[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_9[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_10[] = {  16,   17,   18,   19}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_11[] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73}; //  33
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 33);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_12[] = {  20,   21,   22,   23}; //   4
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_13[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_14[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81}; //  33
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 33);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_15[] = {  28,   29,   30,   31}; //   4
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_16[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40}; //   9
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 9);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");
  int needed_g_d_17[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49}; //   9
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 9);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(82);
  psi_c_f[no_ps].resize(82);
  psi_c_t[no_ps].resize(82);
  psi_c_d[no_ps].resize(82);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  2,   1}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  2,   1}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  0,   3}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0,   3}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  2,   3}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  2,   3}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  4,   5}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  4,   5}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  6,   5}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  6,   5}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  4,   7}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  4,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  6,   7}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  6,   7}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  8,   9}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  8,   9}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = { 10,   9}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = { 10,   9}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  8,  11}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  8,  11}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = { 10,  11}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = { 10,  11}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = { 12,  13}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = { 12,  13}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = { 14,  13}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {}; //   0
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 0);
  int c_d_26[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = { 14,  13}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {}; //   0
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 0);
  int c_d_27[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = { 12,  15}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {}; //   0
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 0);
  int c_d_28[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = { 12,  15}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {}; //   0
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 0);
  int c_d_29[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = { 14,  15}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {}; //   0
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 0);
  int c_d_30[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = { 14,  15}; //   2
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 2);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {}; //   0
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 0);
  int c_d_31[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  0,  16}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {}; //   0
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 0);
  int c_d_32[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = {  0,  16}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {}; //   0
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 0);
  int c_d_33[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = {  0,  17}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {}; //   0
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 0);
  int c_d_34[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = {  0,  17}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {}; //   0
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 0);
  int c_d_35[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  2,  16}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {}; //   0
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 0);
  int c_d_36[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 3);

  int c_p_37[] = {  2,  16}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {}; //   0
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 0);
  int c_d_37[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 3);

  int c_p_38[] = {  2,  17}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {}; //   0
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 0);
  int c_d_38[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 3);

  int c_p_39[] = {  2,  17}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {}; //   0
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 0);
  int c_d_39[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 3);

  int c_p_40[] = {  2,  17}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {}; //   0
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 0);
  int c_d_40[] = { 16,  14,   2}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  4,  18}; //   2
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 2);
  int c_f_41[] = {}; //   0
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 0);
  int c_t_41[] = {}; //   0
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 0);
  int c_d_41[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  4,  18}; //   2
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 2);
  int c_f_42[] = {}; //   0
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 0);
  int c_t_42[] = {}; //   0
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 0);
  int c_d_42[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  4,  19}; //   2
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 2);
  int c_f_43[] = {}; //   0
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 0);
  int c_t_43[] = {}; //   0
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 0);
  int c_d_43[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  4,  19}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {}; //   0
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 0);
  int c_t_44[] = {}; //   0
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 0);
  int c_d_44[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  6,  18}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {}; //   0
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 0);
  int c_t_45[] = {}; //   0
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 0);
  int c_d_45[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = {  6,  18}; //   2
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 2);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = {}; //   0
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 0);
  int c_d_46[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = {  6,  19}; //   2
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 2);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = {}; //   0
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 0);
  int c_d_47[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  6,  19}; //   2
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 2);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = {}; //   0
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 0);
  int c_d_48[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  6,  19}; //   2
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 2);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = {}; //   0
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 0);
  int c_d_49[] = { 17,  11,   6}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  0,  16}; //   2
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 2);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = {  0}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = { 14,   2}; //   2
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 2);

  int c_p_51[] = {  0,  16}; //   2
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 2);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = {  1}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = { 14,   2}; //   2
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 2);

  int c_p_52[] = {  0,  17}; //   2
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 2);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  0}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = { 14,   2}; //   2
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 2);

  int c_p_53[] = {  0,  17}; //   2
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 2);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  1}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = { 14,   2}; //   2
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 2);

  int c_p_54[] = {  2,  16}; //   2
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 2);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = {  0}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = { 14,   2}; //   2
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 2);

  int c_p_55[] = {  2,  16}; //   2
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 2);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = {  1}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = { 14,   2}; //   2
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 2);

  int c_p_56[] = {  2,  17}; //   2
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 2);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = {  0}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = { 14,   2}; //   2
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 2);

  int c_p_57[] = {  2,  17}; //   2
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 2);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = {  1}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = { 14,   2}; //   2
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 2);

  int c_p_58[] = {  4,  18}; //   2
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 2);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = {  2}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = { 11,   6}; //   2
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 2);

  int c_p_59[] = {  4,  18}; //   2
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 2);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = {  3}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = { 11,   6}; //   2
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 2);

  int c_p_60[] = {  4,  19}; //   2
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 2);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = {  2}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = { 11,   6}; //   2
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 2);

  int c_p_61[] = {  4,  19}; //   2
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 2);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = {  3}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = { 11,   6}; //   2
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 2);

  int c_p_62[] = {  6,  18}; //   2
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 2);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = {  2}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = { 11,   6}; //   2
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 2);

  int c_p_63[] = {  6,  18}; //   2
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 2);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = {  3}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = { 11,   6}; //   2
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 2);

  int c_p_64[] = {  6,  19}; //   2
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 2);
  int c_f_64[] = {}; //   0
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 0);
  int c_t_64[] = {  2}; //   1
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 1);
  int c_d_64[] = { 11,   6}; //   2
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 2);

  int c_p_65[] = {  6,  19}; //   2
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 2);
  int c_f_65[] = {}; //   0
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 0);
  int c_t_65[] = {  3}; //   1
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 1);
  int c_d_65[] = { 11,   6}; //   2
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 2);

  int c_p_66[] = {  8,  20}; //   2
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 2);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = {  4}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = {  6,  11}; //   2
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 2);

  int c_p_67[] = {  8,  20}; //   2
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 2);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = {  5}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = {  6,  11}; //   2
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 2);

  int c_p_68[] = {  8,  21}; //   2
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 2);
  int c_f_68[] = {}; //   0
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 0);
  int c_t_68[] = {  4}; //   1
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 1);
  int c_d_68[] = {  6,  11}; //   2
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 2);

  int c_p_69[] = {  8,  21}; //   2
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 2);
  int c_f_69[] = {}; //   0
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 0);
  int c_t_69[] = {  5}; //   1
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 1);
  int c_d_69[] = {  6,  11}; //   2
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 2);

  int c_p_70[] = { 10,  20}; //   2
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 2);
  int c_f_70[] = {}; //   0
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 0);
  int c_t_70[] = {  4}; //   1
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 1);
  int c_d_70[] = {  6,  11}; //   2
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 2);

  int c_p_71[] = { 10,  20}; //   2
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 2);
  int c_f_71[] = {}; //   0
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 0);
  int c_t_71[] = {  5}; //   1
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 1);
  int c_d_71[] = {  6,  11}; //   2
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 2);

  int c_p_72[] = { 10,  21}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {}; //   0
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 0);
  int c_t_72[] = {  4}; //   1
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 1);
  int c_d_72[] = {  6,  11}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = { 10,  21}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = {}; //   0
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 0);
  int c_t_73[] = {  5}; //   1
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 1);
  int c_d_73[] = {  6,  11}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = { 12,  22}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = {}; //   0
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 0);
  int c_t_74[] = {  6}; //   1
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 1);
  int c_d_74[] = {  2,  14}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = { 12,  22}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {}; //   0
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 0);
  int c_t_75[] = {  7}; //   1
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 1);
  int c_d_75[] = {  2,  14}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = { 12,  23}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = {}; //   0
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 0);
  int c_t_76[] = {  6}; //   1
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 1);
  int c_d_76[] = {  2,  14}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = { 12,  23}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = {}; //   0
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 0);
  int c_t_77[] = {  7}; //   1
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 1);
  int c_d_77[] = {  2,  14}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = { 14,  22}; //   2
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 2);
  int c_f_78[] = {}; //   0
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 0);
  int c_t_78[] = {  6}; //   1
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 1);
  int c_d_78[] = {  2,  14}; //   2
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 2);

  int c_p_79[] = { 14,  22}; //   2
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 2);
  int c_f_79[] = {}; //   0
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 0);
  int c_t_79[] = {  7}; //   1
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 1);
  int c_d_79[] = {  2,  14}; //   2
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 2);

  int c_p_80[] = { 14,  23}; //   2
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 2);
  int c_f_80[] = {}; //   0
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 0);
  int c_t_80[] = {  6}; //   1
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 1);
  int c_d_80[] = {  2,  14}; //   2
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 2);

  int c_p_81[] = { 14,  23}; //   2
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 2);
  int c_f_81[] = {}; //   0
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 0);
  int c_t_81[] = {  7}; //   1
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 1);
  int c_d_81[] = {  2,  14}; //   2
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
