#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeex02/header/ppeex02.phasespace.h"
void ppeex02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppeex02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeex02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeex02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 6;}
  else if (psi_no_map[no_ps] == 2){n_channel = 4;}
  else if (psi_no_map[no_ps] == 3){n_channel = 4;}
  else if (psi_no_map[no_ps] == 4){n_channel = 4;}
  else if (psi_no_map[no_ps] == 5){n_channel = 4;}
  else if (psi_no_map[no_ps] == 6){n_channel = 4;}
  else if (psi_no_map[no_ps] == 7){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeex02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeex02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeex02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeex02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppeex02_ax_psp_120_gd_emepd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppeex02_ax_psp_120_gu_emepu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppeex02_ax_psp_120_gdx_emepdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppeex02_ax_psp_120_gux_emepux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppeex02_ax_psp_120_ddx_emepg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppeex02_ax_psp_120_uux_emepg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
