#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemxnmnex04/header/ppemxnmnex04.phasespace.h"
void ppemxnmnex04_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppemxnmnex04_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemxnmnex04_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 69;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 19;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 19;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 21;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 19;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 19;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 21;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 19;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 19;}
  else if (psi_no_map[no_ps] == 10){n_channel = 21;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemxnmnex04_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemxnmnex04_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppemxnmnex04_ax_psp_140_gd_emmupvmvexd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppemxnmnex04_ax_psp_140_gu_emmupvmvexu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppemxnmnex04_ax_psp_140_gb_emmupvmvexb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppemxnmnex04_ax_psp_140_gdx_emmupvmvexdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppemxnmnex04_ax_psp_140_gux_emmupvmvexux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppemxnmnex04_ax_psp_140_gbx_emmupvmvexbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppemxnmnex04_ax_psp_140_ddx_emmupvmvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppemxnmnex04_ax_psp_140_uux_emmupvmvexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppemxnmnex04_ax_psp_140_bbx_emmupvmvexg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
