#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenexa03/header/ppenexa03.phasespace.h"
void ppenexa03_ax_psp_230_dcx_emvexadsx(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_ax_psp_230_dcx_emvexadsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(13);
  psi_needed_v_smin[no_ps].resize(13);
  int needed_v_smin_0[] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13}; //  12
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 12);
  int needed_v_smin_1[] = {   0,    1,    6,   11,    5,   12}; //   6
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 6);
  int needed_v_smin_2[] = {   1,    0,    5}; //   3
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 3);
  int needed_v_smin_3[] = {   2,    7}; //   2
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 2);
  int needed_v_smin_4[] = {   2,    3,    7,    8}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   3,    8}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {   3,    8}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   4,   13,   10}; //   3
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 3);
  int needed_v_smin_8[] = {   4,   10,   13}; //   3
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 3);
  int needed_v_smin_9[] = {  11,   12}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6}; //   1
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 1);
  int needed_v_smin_11[] = {   9}; //   1
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 1);
  int needed_v_smin_12[] = {   9}; //   1
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 1);

  psi_v_smax[no_ps].resize(13);
  psi_needed_v_smax[no_ps].resize(13);
  int needed_v_smax_0[] = {   0,    1,    2,    5,    6,    7,    9,   10,   11,   12,   13}; //  11
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 11);
  int needed_v_smax_1[] = {   0,    1,    6,   11,    5}; //   5
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 5);
  int needed_v_smax_2[] = {   1,    2,    3,    4,    0,    5,    7,    8,   10,   13}; //  10
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 10);
  int needed_v_smax_3[] = {   2,    3,    7,    8}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   3,    8}; //   2
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   4}; //   1
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   4}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);
  int needed_v_smax_7[] = {  11}; //   1
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 1);
  int needed_v_smax_8[] = {  12}; //   1
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 1);
  int needed_v_smax_9[] = {  13,   10}; //   2
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 2);
  int needed_v_smax_10[] = {   6,    9}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {   9}; //   1
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 1);
  int needed_v_smax_12[] = {  12}; //   1
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(13);
  psi_needed_g_p[no_ps].resize(13);
  int needed_g_p_0[] = {   0,    1,    2,    5,    6,    7,    9,   10,   11,   12,   13}; //  11
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 11);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    6,   11}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   1}; //   1
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   2,    7}; //   2
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 2);
  psi_container_IS_name.push_back("propagator_24_smin3_smax3");
  int needed_g_p_4[] = {   2,    3}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_5[] = {   3,    8}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {   3,    8}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_24_smin6_smax3");
  int needed_g_p_7[] = {   4}; //   1
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_8[] = {   4}; //   1
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 1);
  psi_container_IS_name.push_back("propagator_24_smin0_smax6");
  int needed_g_p_9[] = {   4}; //   1
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 1);
  psi_container_IS_name.push_back("propagator_0_smin8_smax2");
  int needed_g_p_10[] = {  11}; //   1
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 1);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_11[] = {  12}; //   1
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 1);
  psi_container_IS_name.push_back("propagator_0_smin9_smax8");
  int needed_g_p_12[] = {  13}; //   1
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax9");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(9);
  psi_needed_g_f[no_ps].resize(9);
  int needed_g_f_0[] = {   0,    5}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_1[] = {   5}; //   1
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_2[] = {   6}; //   1
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax10");
  int needed_g_f_3[] = {   7,    8}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax2");
  int needed_g_f_4[] = {   9}; //   1
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax11");
  int needed_g_f_5[] = {   9}; //   1
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax10");
  int needed_g_f_6[] = {  10}; //   1
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax9");
  int needed_g_f_7[] = {  10,   13}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax2");
  int needed_g_f_8[] = {  12}; //   1
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax12");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(12);
  psi_needed_g_t[no_ps].resize(12);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    7,    8,   10,   13}; //  10
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_1[] = {   0,    5}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_2[] = {   5}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_3[] = {   6,    9}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_4[] = {   6}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__32_76");
  int needed_g_t_5[] = {   7,    8}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__64_28");
  int needed_g_t_6[] = {   9}; //   1
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_7[] = {   9}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_8[] = {  10,   13}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_9[] = {  10}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_10[] = {  11,   12}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_11[] = {  12}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(10);
  psi_needed_g_d[no_ps].resize(10);
  int needed_g_d_0[] = {   0,    1,    6,   11}; //   4
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_1[] = {   0,    1,    2,    4,    5,    6,    7,    9,   10,   11,   12,   13}; //  12
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 12);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_2[] = {   1}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_3[] = {   2,    3}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_4[] = {   2,    7}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_5[] = {   3,    8}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_6[] = {   3,    8}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_7[] = {   4}; //   1
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_8[] = {   4,   13}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_9[] = {  11,   12}; //   2
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 2);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");

  psi_c_p[no_ps].resize(14);
  psi_c_f[no_ps].resize(14);
  psi_c_t[no_ps].resize(14);
  psi_c_d[no_ps].resize(14);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1}; //   2
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 2);

  int c_p_1[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  0}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  2,   0,   1}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   3,   4}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  0}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  3,   4,   1}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  5,   6,   4}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  0}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  3,   5,   6}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  7,   8,   9}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  0}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  7,   1,   8}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  1,   0}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {  1}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0,   1}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {  2}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  3,   4}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  0,   1}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  0,   3}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {  3}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  0,   5}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  4,   1}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  5,   6}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {  3}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   5}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  5,   6}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  0}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = {  4,   5}; //   2
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 2);
  int c_t_9[] = {  3,   6,   7}; //   3
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 3);
  int c_d_9[] = {  1}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  0}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  6,   7}; //   2
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 2);
  int c_t_10[] = {  0,   8,   9}; //   3
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 3);
  int c_d_10[] = {  1}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  0,   1,  10}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = { 10}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  9,   0,   1}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,  11}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {  8}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = { 10,  11}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  9,   1}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  0,  12}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {  7}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = {  0,   8}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  8,   1}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
