#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenexa03/header/ppnenexa03.phasespace.h"
void ppnenexa03_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppnenexa03_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppnenexa03_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 86;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 40;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 20;}
  else if (psi_no_map[no_ps] == 10){n_channel = 20;}
  else if (psi_no_map[no_ps] == 11){n_channel = 20;}
  else if (psi_no_map[no_ps] == 13){n_channel = 30;}
  else if (psi_no_map[no_ps] == 14){n_channel = 40;}
  else if (psi_no_map[no_ps] == 15){n_channel = 20;}
  else if (psi_no_map[no_ps] == 16){n_channel = 20;}
  else if (psi_no_map[no_ps] == 17){n_channel = 20;}
  else if (psi_no_map[no_ps] == 18){n_channel = 20;}
  else if (psi_no_map[no_ps] == 20){n_channel = 20;}
  else if (psi_no_map[no_ps] == 22){n_channel = 20;}
  else if (psi_no_map[no_ps] == 23){n_channel = 40;}
  else if (psi_no_map[no_ps] == 24){n_channel = 20;}
  else if (psi_no_map[no_ps] == 25){n_channel = 20;}
  else if (psi_no_map[no_ps] == 27){n_channel = 30;}
  else if (psi_no_map[no_ps] == 28){n_channel = 20;}
  else if (psi_no_map[no_ps] == 29){n_channel = 40;}
  else if (psi_no_map[no_ps] == 30){n_channel = 20;}
  else if (psi_no_map[no_ps] == 31){n_channel = 20;}
  else if (psi_no_map[no_ps] == 32){n_channel = 20;}
  else if (psi_no_map[no_ps] == 34){n_channel = 20;}
  else if (psi_no_map[no_ps] == 35){n_channel = 40;}
  else if (psi_no_map[no_ps] == 36){n_channel = 20;}
  else if (psi_no_map[no_ps] == 37){n_channel = 20;}
  else if (psi_no_map[no_ps] == 38){n_channel = 20;}
  else if (psi_no_map[no_ps] == 40){n_channel = 40;}
  else if (psi_no_map[no_ps] == 41){n_channel = 20;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenexa03_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppnenexa03_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenexa03_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppnenexa03_ax_psp_230_gg_vevexaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppnenexa03_ax_psp_230_gg_vevexauux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppnenexa03_ax_psp_230_gd_vevexagd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppnenexa03_ax_psp_230_gu_vevexagu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppnenexa03_ax_psp_230_gdx_vevexagdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppnenexa03_ax_psp_230_gux_vevexagux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppnenexa03_ax_psp_230_dd_vevexadd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppnenexa03_ax_psp_230_du_vevexadu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppnenexa03_ax_psp_230_ds_vevexads(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppnenexa03_ax_psp_230_dc_vevexadc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppnenexa03_ax_psp_230_ddx_vevexagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppnenexa03_ax_psp_230_ddx_vevexaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppnenexa03_ax_psp_230_ddx_vevexauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppnenexa03_ax_psp_230_ddx_vevexassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppnenexa03_ax_psp_230_ddx_vevexaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppnenexa03_ax_psp_230_dux_vevexadux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppnenexa03_ax_psp_230_dsx_vevexadsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppnenexa03_ax_psp_230_dcx_vevexadcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppnenexa03_ax_psp_230_uu_vevexauu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppnenexa03_ax_psp_230_uc_vevexauc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppnenexa03_ax_psp_230_udx_vevexaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppnenexa03_ax_psp_230_uux_vevexagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppnenexa03_ax_psp_230_uux_vevexaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppnenexa03_ax_psp_230_uux_vevexauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppnenexa03_ax_psp_230_uux_vevexassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppnenexa03_ax_psp_230_uux_vevexaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppnenexa03_ax_psp_230_usx_vevexausx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppnenexa03_ax_psp_230_ucx_vevexaucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppnenexa03_ax_psp_230_dxdx_vevexadxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppnenexa03_ax_psp_230_dxux_vevexadxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppnenexa03_ax_psp_230_dxsx_vevexadxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppnenexa03_ax_psp_230_dxcx_vevexadxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppnenexa03_ax_psp_230_uxux_vevexauxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppnenexa03_ax_psp_230_uxcx_vevexauxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
