#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppw01/header/ppw01.phasespace.h"
void ppw01_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppw01_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppw01_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==   0){n_channel = 60;}
  else if (psi_no_map[no_ps] ==   1){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==   9){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  10){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  11){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  12){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  13){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  14){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  15){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  16){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  17){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  18){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  19){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  20){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  25){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  26){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  28){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  29){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  30){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  32){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  35){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  36){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  37){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  38){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  40){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  42){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  43){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  44){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  45){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  46){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  47){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  48){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  49){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  50){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  51){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  52){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  53){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  56){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  58){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  59){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  62){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  64){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  67){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  69){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  70){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  71){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  72){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  73){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  74){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  76){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  79){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  82){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  85){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  88){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  89){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  90){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  92){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  93){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  95){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  96){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  97){n_channel = 4;}
  else if (psi_no_map[no_ps] ==  98){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  99){n_channel = 2;}
  else if (psi_no_map[no_ps] == 100){n_channel = 2;}
  else if (psi_no_map[no_ps] == 101){n_channel = 2;}
  else if (psi_no_map[no_ps] == 102){n_channel = 2;}
  else if (psi_no_map[no_ps] == 103){n_channel = 2;}
  else if (psi_no_map[no_ps] == 109){n_channel = 4;}
  else if (psi_no_map[no_ps] == 111){n_channel = 4;}
  else if (psi_no_map[no_ps] == 114){n_channel = 2;}
  else if (psi_no_map[no_ps] == 115){n_channel = 4;}
  else if (psi_no_map[no_ps] == 118){n_channel = 2;}
  else if (psi_no_map[no_ps] == 119){n_channel = 2;}
  else if (psi_no_map[no_ps] == 120){n_channel = 2;}
  else if (psi_no_map[no_ps] == 121){n_channel = 2;}
  else if (psi_no_map[no_ps] == 122){n_channel = 2;}
  else if (psi_no_map[no_ps] == 125){n_channel = 2;}
  else if (psi_no_map[no_ps] == 128){n_channel = 8;}
  else if (psi_no_map[no_ps] == 129){n_channel = 2;}
  else if (psi_no_map[no_ps] == 132){n_channel = 4;}
  else if (psi_no_map[no_ps] == 134){n_channel = 2;}
  else if (psi_no_map[no_ps] == 135){n_channel = 4;}
  else if (psi_no_map[no_ps] == 136){n_channel = 2;}
  else if (psi_no_map[no_ps] == 137){n_channel = 2;}
  else if (psi_no_map[no_ps] == 138){n_channel = 2;}
  else if (psi_no_map[no_ps] == 141){n_channel = 2;}
  else if (psi_no_map[no_ps] == 142){n_channel = 2;}
  else if (psi_no_map[no_ps] == 143){n_channel = 4;}
  else if (psi_no_map[no_ps] == 144){n_channel = 2;}
  else if (psi_no_map[no_ps] == 145){n_channel = 2;}
  else if (psi_no_map[no_ps] == 146){n_channel = 4;}
  else if (psi_no_map[no_ps] == 147){n_channel = 2;}
  else if (psi_no_map[no_ps] == 148){n_channel = 8;}
  else if (psi_no_map[no_ps] == 149){n_channel = 2;}
  else if (psi_no_map[no_ps] == 152){n_channel = 2;}
  else if (psi_no_map[no_ps] == 153){n_channel = 2;}
  else if (psi_no_map[no_ps] == 154){n_channel = 2;}
  else if (psi_no_map[no_ps] == 155){n_channel = 4;}
  else if (psi_no_map[no_ps] == 156){n_channel = 2;}
  else if (psi_no_map[no_ps] == 158){n_channel = 4;}
  else if (psi_no_map[no_ps] == 161){n_channel = 2;}
  else if (psi_no_map[no_ps] == 164){n_channel = 2;}
  else if (psi_no_map[no_ps] == 167){n_channel = 2;}
  else if (psi_no_map[no_ps] == 169){n_channel = 2;}
  else if (psi_no_map[no_ps] == 170){n_channel = 4;}
  else if (psi_no_map[no_ps] == 174){n_channel = 2;}
  else if (psi_no_map[no_ps] == 175){n_channel = 2;}
  else if (psi_no_map[no_ps] == 176){n_channel = 2;}
  else if (psi_no_map[no_ps] == 177){n_channel = 2;}
  else if (psi_no_map[no_ps] == 178){n_channel = 2;}
  else if (psi_no_map[no_ps] == 179){n_channel = 2;}
  else if (psi_no_map[no_ps] == 180){n_channel = 4;}
  else if (psi_no_map[no_ps] == 181){n_channel = 4;}
  else if (psi_no_map[no_ps] == 182){n_channel = 4;}
  else if (psi_no_map[no_ps] == 186){n_channel = 4;}
  else if (psi_no_map[no_ps] == 188){n_channel = 4;}
  else if (psi_no_map[no_ps] == 189){n_channel = 2;}
  else if (psi_no_map[no_ps] == 192){n_channel = 2;}
  else if (psi_no_map[no_ps] == 195){n_channel = 8;}
  else if (psi_no_map[no_ps] == 196){n_channel = 2;}
  else if (psi_no_map[no_ps] == 199){n_channel = 4;}
  else if (psi_no_map[no_ps] == 202){n_channel = 2;}
  else if (psi_no_map[no_ps] == 204){n_channel = 2;}
  else if (psi_no_map[no_ps] == 205){n_channel = 2;}
  else if (psi_no_map[no_ps] == 206){n_channel = 2;}
  else if (psi_no_map[no_ps] == 207){n_channel = 2;}
  else if (psi_no_map[no_ps] == 208){n_channel = 4;}
  else if (psi_no_map[no_ps] == 210){n_channel = 2;}
  else if (psi_no_map[no_ps] == 213){n_channel = 2;}
  else if (psi_no_map[no_ps] == 215){n_channel = 8;}
  else if (psi_no_map[no_ps] == 216){n_channel = 2;}
  else if (psi_no_map[no_ps] == 219){n_channel = 2;}
  else if (psi_no_map[no_ps] == 220){n_channel = 2;}
  else if (psi_no_map[no_ps] == 222){n_channel = 2;}
  else if (psi_no_map[no_ps] == 225){n_channel = 4;}
  else if (psi_no_map[no_ps] == 226){n_channel = 2;}
  else if (psi_no_map[no_ps] == 227){n_channel = 2;}
  else if (psi_no_map[no_ps] == 228){n_channel = 4;}
  else if (psi_no_map[no_ps] == 229){n_channel = 2;}
  else if (psi_no_map[no_ps] == 230){n_channel = 2;}
  else if (psi_no_map[no_ps] == 231){n_channel = 4;}
  else if (psi_no_map[no_ps] == 232){n_channel = 2;}
  else if (psi_no_map[no_ps] == 233){n_channel = 2;}
  else if (psi_no_map[no_ps] == 234){n_channel = 4;}
  else if (psi_no_map[no_ps] == 235){n_channel = 4;}
  else if (psi_no_map[no_ps] == 236){n_channel = 2;}
  else if (psi_no_map[no_ps] == 237){n_channel = 2;}
  else if (psi_no_map[no_ps] == 241){n_channel = 4;}
  else if (psi_no_map[no_ps] == 242){n_channel = 2;}
  else if (psi_no_map[no_ps] == 243){n_channel = 2;}
  else if (psi_no_map[no_ps] == 247){n_channel = 4;}
  else if (psi_no_map[no_ps] == 249){n_channel = 4;}
  else if (psi_no_map[no_ps] == 250){n_channel = 4;}
  else if (psi_no_map[no_ps] == 254){n_channel = 2;}
  else if (psi_no_map[no_ps] == 256){n_channel = 4;}
  else if (psi_no_map[no_ps] == 257){n_channel = 2;}
  else if (psi_no_map[no_ps] == 259){n_channel = 2;}
  else if (psi_no_map[no_ps] == 260){n_channel = 2;}
  else if (psi_no_map[no_ps] == 261){n_channel = 2;}
  else if (psi_no_map[no_ps] == 262){n_channel = 2;}
  else if (psi_no_map[no_ps] == 263){n_channel = 2;}
  else if (psi_no_map[no_ps] == 264){n_channel = 2;}
  else if (psi_no_map[no_ps] == 267){n_channel = 2;}
  else if (psi_no_map[no_ps] == 269){n_channel = 2;}
  else if (psi_no_map[no_ps] == 270){n_channel = 4;}
  else if (psi_no_map[no_ps] == 272){n_channel = 2;}
  else if (psi_no_map[no_ps] == 274){n_channel = 4;}
  else if (psi_no_map[no_ps] == 275){n_channel = 2;}
  else if (psi_no_map[no_ps] == 278){n_channel = 4;}
  else if (psi_no_map[no_ps] == 281){n_channel = 4;}
  else if (psi_no_map[no_ps] == 282){n_channel = 4;}
  else if (psi_no_map[no_ps] == 285){n_channel = 2;}
  else if (psi_no_map[no_ps] == 287){n_channel = 2;}
  else if (psi_no_map[no_ps] == 288){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppw01_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==   1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==   9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  42){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  45){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  46){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  47){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  48){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  50){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  53){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  62){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  64){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  67){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  69){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  70){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  71){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  72){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  73){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  74){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  76){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  79){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  82){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  85){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  88){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  89){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  90){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  92){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  93){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  95){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  96){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  97){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  98){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  99){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 100){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 101){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 102){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 103){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 109){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 111){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 114){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 115){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 118){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 119){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 120){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 121){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 122){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 125){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 128){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 129){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 132){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 134){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 135){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 136){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 137){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 138){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 141){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 142){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 143){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 144){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 145){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 146){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 147){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 148){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 149){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 152){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 153){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 154){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 155){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 156){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 158){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 161){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 164){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 167){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 169){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 170){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 174){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 175){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 176){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 177){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 178){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 179){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 180){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 181){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 182){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 186){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 188){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 189){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 192){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 195){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 196){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 199){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 202){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 204){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 205){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 206){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 207){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 208){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 210){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 213){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 215){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 216){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 219){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 220){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 222){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 225){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 226){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 227){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 228){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 229){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 230){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 231){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 232){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 233){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 234){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 235){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 236){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 237){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 241){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 242){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 243){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 247){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 249){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 250){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 254){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 256){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 257){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 259){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 260){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 261){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 262){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 263){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 264){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 267){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 269){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 270){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 272){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 274){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 275){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 278){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 281){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 282){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 285){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 287){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 288){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==   1){ppw01_ax_psp_210_gg_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   2){ppw01_ax_psp_210_gg_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   3){ppw01_ax_psp_210_gg_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   4){ppw01_ax_psp_210_gg_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   5){ppw01_ax_psp_210_gg_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   6){ppw01_ax_psp_210_gg_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   7){ppw01_ax_psp_210_gd_wmgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   8){ppw01_ax_psp_210_gd_wmgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==   9){ppw01_ax_psp_210_gs_wmgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  10){ppw01_ax_psp_210_gs_wmgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  11){ppw01_ax_psp_210_gb_wmgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  12){ppw01_ax_psp_210_gb_wmgc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  13){ppw01_ax_psp_210_gux_wmgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  14){ppw01_ax_psp_210_gux_wmgsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  15){ppw01_ax_psp_210_gux_wmgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  16){ppw01_ax_psp_210_gcx_wmgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  17){ppw01_ax_psp_210_gcx_wmgsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  18){ppw01_ax_psp_210_gcx_wmgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  19){ppw01_ax_psp_210_dd_wmdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  20){ppw01_ax_psp_210_dd_wmdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  25){ppw01_ax_psp_210_du_wmuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  26){ppw01_ax_psp_210_du_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  28){ppw01_ax_psp_210_ds_wmdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  29){ppw01_ax_psp_210_ds_wmdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  30){ppw01_ax_psp_210_ds_wmus(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  32){ppw01_ax_psp_210_ds_wmsc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  35){ppw01_ax_psp_210_dc_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  36){ppw01_ax_psp_210_dc_wmcc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  37){ppw01_ax_psp_210_db_wmdu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  38){ppw01_ax_psp_210_db_wmdc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  40){ppw01_ax_psp_210_db_wmub(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  42){ppw01_ax_psp_210_db_wmcb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  43){ppw01_ax_psp_210_ddx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  44){ppw01_ax_psp_210_ddx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  45){ppw01_ax_psp_210_ddx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  46){ppw01_ax_psp_210_ddx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  47){ppw01_ax_psp_210_ddx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  48){ppw01_ax_psp_210_ddx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  49){ppw01_ax_psp_210_dux_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  50){ppw01_ax_psp_210_dux_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  51){ppw01_ax_psp_210_dux_wmdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  52){ppw01_ax_psp_210_dux_wmdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  53){ppw01_ax_psp_210_dux_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  56){ppw01_ax_psp_210_dux_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  58){ppw01_ax_psp_210_dux_wmcux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  59){ppw01_ax_psp_210_dux_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  62){ppw01_ax_psp_210_dux_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  64){ppw01_ax_psp_210_dsx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  67){ppw01_ax_psp_210_dsx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  69){ppw01_ax_psp_210_dcx_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  70){ppw01_ax_psp_210_dcx_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  71){ppw01_ax_psp_210_dcx_wmdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  72){ppw01_ax_psp_210_dcx_wmdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  73){ppw01_ax_psp_210_dcx_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  74){ppw01_ax_psp_210_dcx_wmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  76){ppw01_ax_psp_210_dcx_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  79){ppw01_ax_psp_210_dcx_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  82){ppw01_ax_psp_210_dcx_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  85){ppw01_ax_psp_210_dbx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  88){ppw01_ax_psp_210_dbx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  89){ppw01_ax_psp_210_us_wmuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  90){ppw01_ax_psp_210_us_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  92){ppw01_ax_psp_210_ub_wmuu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  93){ppw01_ax_psp_210_ub_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  95){ppw01_ax_psp_210_uux_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  96){ppw01_ax_psp_210_uux_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  97){ppw01_ax_psp_210_uux_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  98){ppw01_ax_psp_210_uux_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  99){ppw01_ax_psp_210_uux_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 100){ppw01_ax_psp_210_uux_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 101){ppw01_ax_psp_210_ucx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 102){ppw01_ax_psp_210_ucx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 103){ppw01_ax_psp_210_ucx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 109){ppw01_ax_psp_210_ss_wmus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 111){ppw01_ax_psp_210_ss_wmsc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 114){ppw01_ax_psp_210_sc_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 115){ppw01_ax_psp_210_sc_wmcc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 118){ppw01_ax_psp_210_sb_wmus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 119){ppw01_ax_psp_210_sb_wmub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 120){ppw01_ax_psp_210_sb_wmsc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 121){ppw01_ax_psp_210_sb_wmcb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 122){ppw01_ax_psp_210_sdx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 125){ppw01_ax_psp_210_sdx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 128){ppw01_ax_psp_210_sux_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 129){ppw01_ax_psp_210_sux_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 132){ppw01_ax_psp_210_sux_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 134){ppw01_ax_psp_210_sux_wmsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 135){ppw01_ax_psp_210_sux_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 136){ppw01_ax_psp_210_sux_wmsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 137){ppw01_ax_psp_210_sux_wmcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 138){ppw01_ax_psp_210_sux_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 141){ppw01_ax_psp_210_sux_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 142){ppw01_ax_psp_210_ssx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 143){ppw01_ax_psp_210_ssx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 144){ppw01_ax_psp_210_ssx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 145){ppw01_ax_psp_210_ssx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 146){ppw01_ax_psp_210_ssx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 147){ppw01_ax_psp_210_ssx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 148){ppw01_ax_psp_210_scx_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 149){ppw01_ax_psp_210_scx_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 152){ppw01_ax_psp_210_scx_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 153){ppw01_ax_psp_210_scx_wmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 154){ppw01_ax_psp_210_scx_wmsdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 155){ppw01_ax_psp_210_scx_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 156){ppw01_ax_psp_210_scx_wmsbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 158){ppw01_ax_psp_210_scx_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 161){ppw01_ax_psp_210_scx_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 164){ppw01_ax_psp_210_sbx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 167){ppw01_ax_psp_210_sbx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 169){ppw01_ax_psp_210_cb_wmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 170){ppw01_ax_psp_210_cb_wmcc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 174){ppw01_ax_psp_210_cux_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 175){ppw01_ax_psp_210_cux_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 176){ppw01_ax_psp_210_cux_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 177){ppw01_ax_psp_210_ccx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 178){ppw01_ax_psp_210_ccx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 179){ppw01_ax_psp_210_ccx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 180){ppw01_ax_psp_210_ccx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 181){ppw01_ax_psp_210_ccx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 182){ppw01_ax_psp_210_ccx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 186){ppw01_ax_psp_210_bb_wmub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 188){ppw01_ax_psp_210_bb_wmcb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 189){ppw01_ax_psp_210_bdx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 192){ppw01_ax_psp_210_bdx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 195){ppw01_ax_psp_210_bux_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 196){ppw01_ax_psp_210_bux_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 199){ppw01_ax_psp_210_bux_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 202){ppw01_ax_psp_210_bux_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 204){ppw01_ax_psp_210_bux_wmcux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 205){ppw01_ax_psp_210_bux_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 206){ppw01_ax_psp_210_bux_wmbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 207){ppw01_ax_psp_210_bux_wmbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 208){ppw01_ax_psp_210_bux_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 210){ppw01_ax_psp_210_bsx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 213){ppw01_ax_psp_210_bsx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 215){ppw01_ax_psp_210_bcx_wmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 216){ppw01_ax_psp_210_bcx_wmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 219){ppw01_ax_psp_210_bcx_wmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 220){ppw01_ax_psp_210_bcx_wmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 222){ppw01_ax_psp_210_bcx_wmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 225){ppw01_ax_psp_210_bcx_wmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 226){ppw01_ax_psp_210_bcx_wmbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 227){ppw01_ax_psp_210_bcx_wmbsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 228){ppw01_ax_psp_210_bcx_wmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 229){ppw01_ax_psp_210_bbx_wmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 230){ppw01_ax_psp_210_bbx_wmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 231){ppw01_ax_psp_210_bbx_wmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 232){ppw01_ax_psp_210_bbx_wmcdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 233){ppw01_ax_psp_210_bbx_wmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 234){ppw01_ax_psp_210_bbx_wmcbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 235){ppw01_ax_psp_210_dxux_wmdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 236){ppw01_ax_psp_210_dxux_wmdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 237){ppw01_ax_psp_210_dxux_wmdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 241){ppw01_ax_psp_210_dxcx_wmdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 242){ppw01_ax_psp_210_dxcx_wmdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 243){ppw01_ax_psp_210_dxcx_wmdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 247){ppw01_ax_psp_210_uxux_wmdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 249){ppw01_ax_psp_210_uxux_wmuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 250){ppw01_ax_psp_210_uxux_wmuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 254){ppw01_ax_psp_210_uxsx_wmdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 256){ppw01_ax_psp_210_uxsx_wmsxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 257){ppw01_ax_psp_210_uxsx_wmsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 259){ppw01_ax_psp_210_uxcx_wmdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 260){ppw01_ax_psp_210_uxcx_wmdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 261){ppw01_ax_psp_210_uxcx_wmuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 262){ppw01_ax_psp_210_uxcx_wmuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 263){ppw01_ax_psp_210_uxcx_wmsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 264){ppw01_ax_psp_210_uxcx_wmcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 267){ppw01_ax_psp_210_uxbx_wmdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 269){ppw01_ax_psp_210_uxbx_wmsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 270){ppw01_ax_psp_210_uxbx_wmbxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 272){ppw01_ax_psp_210_sxcx_wmdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 274){ppw01_ax_psp_210_sxcx_wmsxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 275){ppw01_ax_psp_210_sxcx_wmsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 278){ppw01_ax_psp_210_cxcx_wmdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 281){ppw01_ax_psp_210_cxcx_wmsxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 282){ppw01_ax_psp_210_cxcx_wmcxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 285){ppw01_ax_psp_210_cxbx_wmdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 287){ppw01_ax_psp_210_cxbx_wmsxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 288){ppw01_ax_psp_210_cxbx_wmbxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
