#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppw01/header/ppw01.phasespace.h"
void ppw01_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppw01_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppw01_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 12;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 2;}
  else if (psi_no_map[no_ps] == 10){n_channel = 2;}
  else if (psi_no_map[no_ps] == 11){n_channel = 2;}
  else if (psi_no_map[no_ps] == 12){n_channel = 2;}
  else if (psi_no_map[no_ps] == 13){n_channel = 2;}
  else if (psi_no_map[no_ps] == 14){n_channel = 2;}
  else if (psi_no_map[no_ps] == 15){n_channel = 2;}
  else if (psi_no_map[no_ps] == 16){n_channel = 2;}
  else if (psi_no_map[no_ps] == 17){n_channel = 2;}
  else if (psi_no_map[no_ps] == 18){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppw01_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppw01_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppw01_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppw01_ax_psp_110_gd_wmu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppw01_ax_psp_110_gd_wmc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppw01_ax_psp_110_gs_wmu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppw01_ax_psp_110_gs_wmc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppw01_ax_psp_110_gb_wmu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppw01_ax_psp_110_gb_wmc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppw01_ax_psp_110_gux_wmdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppw01_ax_psp_110_gux_wmsx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppw01_ax_psp_110_gux_wmbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppw01_ax_psp_110_gcx_wmdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppw01_ax_psp_110_gcx_wmsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppw01_ax_psp_110_gcx_wmbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppw01_ax_psp_110_dux_wmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppw01_ax_psp_110_dcx_wmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppw01_ax_psp_110_sux_wmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppw01_ax_psp_110_scx_wmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppw01_ax_psp_110_bux_wmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppw01_ax_psp_110_bcx_wmg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
