#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppwxw02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppwxw02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 263;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 31;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 31;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 39;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 31;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 31;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 39;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 31;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 31;}
  else if (psi_no_map[no_ps] == 10){n_channel = 39;}
  else if (psi_no_map[no_ps] == 11){n_channel = 28;}
  else if (psi_no_map[no_ps] == 12){n_channel = 18;}
  else if (psi_no_map[no_ps] == 13){n_channel = 14;}
  else if (psi_no_map[no_ps] == 14){n_channel = 14;}
  else if (psi_no_map[no_ps] == 15){n_channel = 4;}
  else if (psi_no_map[no_ps] == 16){n_channel = 16;}
  else if (psi_no_map[no_ps] == 17){n_channel = 31;}
  else if (psi_no_map[no_ps] == 18){n_channel = 28;}
  else if (psi_no_map[no_ps] == 19){n_channel = 18;}
  else if (psi_no_map[no_ps] == 20){n_channel = 14;}
  else if (psi_no_map[no_ps] == 21){n_channel = 14;}
  else if (psi_no_map[no_ps] == 22){n_channel = 16;}
  else if (psi_no_map[no_ps] == 23){n_channel = 18;}
  else if (psi_no_map[no_ps] == 24){n_channel = 4;}
  else if (psi_no_map[no_ps] == 25){n_channel = 14;}
  else if (psi_no_map[no_ps] == 26){n_channel = 4;}
  else if (psi_no_map[no_ps] == 27){n_channel = 14;}
  else if (psi_no_map[no_ps] == 28){n_channel = 16;}
  else if (psi_no_map[no_ps] == 29){n_channel = 28;}
  else if (psi_no_map[no_ps] == 30){n_channel = 14;}
  else if (psi_no_map[no_ps] == 31){n_channel = 16;}
  else if (psi_no_map[no_ps] == 32){n_channel = 18;}
  else if (psi_no_map[no_ps] == 33){n_channel = 4;}
  else if (psi_no_map[no_ps] == 34){n_channel = 31;}
  else if (psi_no_map[no_ps] == 35){n_channel = 18;}
  else if (psi_no_map[no_ps] == 36){n_channel = 28;}
  else if (psi_no_map[no_ps] == 37){n_channel = 14;}
  else if (psi_no_map[no_ps] == 38){n_channel = 14;}
  else if (psi_no_map[no_ps] == 39){n_channel = 16;}
  else if (psi_no_map[no_ps] == 40){n_channel = 14;}
  else if (psi_no_map[no_ps] == 41){n_channel = 4;}
  else if (psi_no_map[no_ps] == 42){n_channel = 14;}
  else if (psi_no_map[no_ps] == 43){n_channel = 16;}
  else if (psi_no_map[no_ps] == 44){n_channel = 36;}
  else if (psi_no_map[no_ps] == 45){n_channel = 16;}
  else if (psi_no_map[no_ps] == 46){n_channel = 16;}
  else if (psi_no_map[no_ps] == 47){n_channel = 39;}
  else if (psi_no_map[no_ps] == 48){n_channel = 16;}
  else if (psi_no_map[no_ps] == 49){n_channel = 16;}
  else if (psi_no_map[no_ps] == 50){n_channel = 36;}
  else if (psi_no_map[no_ps] == 51){n_channel = 28;}
  else if (psi_no_map[no_ps] == 52){n_channel = 18;}
  else if (psi_no_map[no_ps] == 53){n_channel = 14;}
  else if (psi_no_map[no_ps] == 54){n_channel = 14;}
  else if (psi_no_map[no_ps] == 55){n_channel = 4;}
  else if (psi_no_map[no_ps] == 56){n_channel = 16;}
  else if (psi_no_map[no_ps] == 57){n_channel = 28;}
  else if (psi_no_map[no_ps] == 58){n_channel = 14;}
  else if (psi_no_map[no_ps] == 59){n_channel = 16;}
  else if (psi_no_map[no_ps] == 60){n_channel = 36;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwxw02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppwxw02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 26){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 33){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 39){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 42){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 43){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 44){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 45){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 46){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 47){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 48){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 49){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 50){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 51){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 52){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 53){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 54){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 55){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 56){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 57){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 58){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 59){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 60){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwxw02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppwxw02_ax_psp_220_gg_wpwmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppwxw02_ax_psp_220_gg_wpwmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppwxw02_ax_psp_220_gg_wpwmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppwxw02_ax_psp_220_gd_wpwmgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppwxw02_ax_psp_220_gu_wpwmgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppwxw02_ax_psp_220_gb_wpwmgb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppwxw02_ax_psp_220_gdx_wpwmgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppwxw02_ax_psp_220_gux_wpwmgux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppwxw02_ax_psp_220_gbx_wpwmgbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppwxw02_ax_psp_220_dd_wpwmdd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppwxw02_ax_psp_220_du_wpwmdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppwxw02_ax_psp_220_ds_wpwmds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppwxw02_ax_psp_220_dc_wpwmdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppwxw02_ax_psp_220_dc_wpwmus(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppwxw02_ax_psp_220_db_wpwmdb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppwxw02_ax_psp_220_ddx_wpwmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppwxw02_ax_psp_220_ddx_wpwmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppwxw02_ax_psp_220_ddx_wpwmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppwxw02_ax_psp_220_ddx_wpwmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppwxw02_ax_psp_220_ddx_wpwmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppwxw02_ax_psp_220_ddx_wpwmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppwxw02_ax_psp_220_dux_wpwmdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppwxw02_ax_psp_220_dux_wpwmscx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppwxw02_ax_psp_220_dsx_wpwmdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 26){ppwxw02_ax_psp_220_dsx_wpwmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppwxw02_ax_psp_220_dcx_wpwmdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppwxw02_ax_psp_220_dbx_wpwmdbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppwxw02_ax_psp_220_uu_wpwmuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppwxw02_ax_psp_220_uc_wpwmuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppwxw02_ax_psp_220_ub_wpwmub(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppwxw02_ax_psp_220_udx_wpwmudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 33){ppwxw02_ax_psp_220_udx_wpwmcsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppwxw02_ax_psp_220_uux_wpwmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppwxw02_ax_psp_220_uux_wpwmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppwxw02_ax_psp_220_uux_wpwmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppwxw02_ax_psp_220_uux_wpwmssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppwxw02_ax_psp_220_uux_wpwmccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 39){ppwxw02_ax_psp_220_uux_wpwmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppwxw02_ax_psp_220_usx_wpwmusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppwxw02_ax_psp_220_ucx_wpwmdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 42){ppwxw02_ax_psp_220_ucx_wpwmucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 43){ppwxw02_ax_psp_220_ubx_wpwmubx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 44){ppwxw02_ax_psp_220_bb_wpwmbb(no_ps, psi);}
  else if (psi_no_map[no_ps] == 45){ppwxw02_ax_psp_220_bdx_wpwmbdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 46){ppwxw02_ax_psp_220_bux_wpwmbux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 47){ppwxw02_ax_psp_220_bbx_wpwmgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 48){ppwxw02_ax_psp_220_bbx_wpwmddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 49){ppwxw02_ax_psp_220_bbx_wpwmuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 50){ppwxw02_ax_psp_220_bbx_wpwmbbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 51){ppwxw02_ax_psp_220_dxdx_wpwmdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 52){ppwxw02_ax_psp_220_dxux_wpwmdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 53){ppwxw02_ax_psp_220_dxsx_wpwmdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 54){ppwxw02_ax_psp_220_dxcx_wpwmdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 55){ppwxw02_ax_psp_220_dxcx_wpwmuxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 56){ppwxw02_ax_psp_220_dxbx_wpwmdxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 57){ppwxw02_ax_psp_220_uxux_wpwmuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 58){ppwxw02_ax_psp_220_uxcx_wpwmuxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 59){ppwxw02_ax_psp_220_uxbx_wpwmuxbx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 60){ppwxw02_ax_psp_220_bxbx_wpwmbxbx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
