#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppwxw02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppwxw02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 33;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 9;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 9;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 7;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 7;}
  else if (psi_no_map[no_ps] == 10){n_channel = 9;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwxw02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppwxw02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-5);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppwxw02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppwxw02_ax_psp_120_gd_wpwmd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppwxw02_ax_psp_120_gu_wpwmu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppwxw02_ax_psp_120_gb_wpwmb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppwxw02_ax_psp_120_gdx_wpwmdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppwxw02_ax_psp_120_gux_wpwmux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppwxw02_ax_psp_120_gbx_wpwmbx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppwxw02_ax_psp_120_ddx_wpwmg(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppwxw02_ax_psp_120_uux_wpwmg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppwxw02_ax_psp_120_bbx_wpwmg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
