#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppz01/header/ppz01.phasespace.h"
void ppz01_ax_psp_210_gd_zgd(int no_ps, phasespace_set & psi){
  static Logger logger("ppz01_ax_psp_210_gd_zgd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(3);
  psi_needed_v_smin[no_ps].resize(3);
  int needed_v_smin_0[] = {   3,    6,    7,    1}; //   4
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 4);
  int needed_v_smin_1[] = {   4,    5}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    2}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);

  psi_v_smax[no_ps].resize(3);
  psi_needed_v_smax[no_ps].resize(3);
  int needed_v_smax_0[] = {   3,    6,    7,    1}; //   4
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 4);
  int needed_v_smax_1[] = {   4,    5}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    2}; //   2
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(2);
  psi_needed_g_p[no_ps].resize(2);
  int needed_g_p_0[] = {   3,    6,    7}; //   3
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   4,    5}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(2);
  psi_needed_g_f[no_ps].resize(2);
  int needed_g_f_0[] = {   0,    2}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_1[] = {   1}; //   1
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin0_smax0");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(7);
  psi_needed_g_t[no_ps].resize(7);
  int needed_g_t_0[] = {   0,    2}; //   2
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_12");
  int needed_g_t_1[] = {   0}; //   1
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_4");
  int needed_g_t_2[] = {   1,    7}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__8_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__8_20");
  int needed_g_t_3[] = {   1}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__4_16");
  int needed_g_t_4[] = {   2}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__4_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__4_8");
  int needed_g_t_5[] = {   3}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__8_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__8_20");
  int needed_g_t_6[] = {   4}; //   1
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__4_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__4_24");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(4);
  psi_needed_g_d[no_ps].resize(4);
  int needed_g_d_0[] = {   3,    6,    7}; //   3
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 3);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_1[] = {   4,    5}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_2[] = {   5}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_3[] = {   6}; //   1
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");

  psi_c_p[no_ps].resize(8);
  psi_c_f[no_ps].resize(8);
  psi_c_t[no_ps].resize(8);
  psi_c_d[no_ps].resize(8);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  1}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  2,   3}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  0}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  0,   4}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {  0}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  5}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  1}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  6}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  1}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  1}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  2,   1}; //   2
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 2);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  3,   0}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  0}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  2}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
