#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppzz02_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppzz02_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 2;}
    else if (psi_no_map[no_ps] == 2){n_channel = 2;}
    else if (psi_no_map[no_ps] == 3){n_channel = 2;}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 0;}
    else if (psi_no_map[no_ps] == 1){n_channel = 7;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppzz02_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (psi.phasespace_order_alpha_s[no_ps] == 0 && psi.phasespace_order_alpha_e[no_ps] == 2 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 2){
      tau_MC_map.push_back(0);
    }
    else if (psi.no_map[no_ps] == 3){
      tau_MC_map.push_back(0);
    }
  }
  else if (psi.phasespace_order_alpha_s[no_ps] == 2 && psi.phasespace_order_alpha_e[no_ps] == 2 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 1){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-25);
      //  tau_MC_map.push_back(6);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppzz02_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 2){ppzz02_ax_psp_020_ddx_zz(no_ps, psi);}
    else if (psi_no_map[no_ps] == 3){ppzz02_ax_psp_020_uux_zz(no_ps, psi);}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 2 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 1){ppzz02_ax_psp_220_gg_zz(no_ps, psi);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
