#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"

void observable_set::perform_proceeding_in(phasespace_set & psi){
  Logger logger("observable_set::perform_proceeding_in");
  logger << LOG_DEBUG << "started" << endl;

  ifstream in_proceeding(filename_proceeding.c_str());  
  char LineBuffer[128];
  vector<string> readin;
  while (in_proceeding.getline(LineBuffer, 128)) {
    readin.push_back(LineBuffer);
  }
  in_proceeding.close();
  for (int i = readin.size() - 1; i >=0; i--){
    if (readin[i][0] == '#'){
      cout << readin[i] << endl;
      readin.erase(readin.begin() + i);
    }
  }
  logger << LOG_INFO << "proceeding_in size: " << readin.size() << endl;



  logger << LOG_INFO << "Start checking expected content of proceeding_in" << endl;

  int counter = 0;
  int temp_check_size = 11;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  if (switch_CV){
    temp_check_size += 2 * n_qTcut * n_scales_CV;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }
  if (n_moments != 0){
    for (int nm = 0; nm < n_moments; nm++){
      temp_check_size += 2;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      if (switch_CV != 0){
	temp_check_size += 2 * n_qTcut * n_scales_CV;
	if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
	else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      }
    }
  }
  if (switch_distribution != 0){
    int dist_numbers = 3;
    if (switch_CV != 0){dist_numbers += 2 * n_scales_CV;}
    for (int i = 0; i < dat.size(); i++){
      temp_check_size += dist_numbers * dat[i].n_bins;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
    }
    for (int i = 0; i < (dddat).size(); i++){
      temp_check_size += dist_numbers * (dddat)[i].n_bins;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
    }
  }
  if (switch_TSV){
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      temp_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      if (active_qTcut == 1){
      temp_check_size += 2 * n_qTcut * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      }
    }
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      temp_check_size += 2 * n_moments * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
    }
    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}
      for (int i_d = 0; i_d < dat.size(); i_d++){
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  temp_check_size += 1;
	  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
	  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    temp_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
	    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	// not needed here !!!	int i_ddd = dat.size() + i_d;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  temp_check_size += 1;
	  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
	  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    temp_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
	    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
	  }
	}
      }
      next_no_qTcut++;
    }
  }
  temp_check_size += 1;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  int temp_psi_tau_opt_end = atoi(readin[temp_check_size - 1].c_str());
  cout << "# temp_psi_tau_opt_end = " << temp_psi_tau_opt_end << endl;

  if (temp_psi_tau_opt_end != -1){
    temp_check_size += psi_n_tau_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }
  if (temp_psi_tau_opt_end == 0){
    temp_check_size += 4 * psi_n_tau_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }

  temp_check_size += 1;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  cout << "# temp_psi_x1x2_opt_end = " << readin[temp_check_size - 1] << endl;
  int temp_psi_x1x2_opt_end = atoi(readin[temp_check_size - 1].c_str());
  cout << "# temp_psi_x1x2_opt_end = " << temp_psi_x1x2_opt_end << endl;

  if (temp_psi_x1x2_opt_end != -1){
    temp_check_size += psi_n_x1x2_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }
  if (temp_psi_x1x2_opt_end == 0){
    temp_check_size += 4 * psi_n_x1x2_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }
  temp_check_size += 1;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  int temp_psi_z1z2_opt_end = atoi(readin[temp_check_size - 1].c_str());
  cout << "# temp_psi_z1z2_opt_end = " << temp_psi_z1z2_opt_end << endl;

  if (temp_psi_z1z2_opt_end != -1){
    for (int i_z = 1; i_z < 3; i_z++){
      temp_check_size += psi_n_z1z2_bins;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      if (temp_psi_z1z2_opt_end == 0){
      temp_check_size += 4 * psi_n_z1z2_bins;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
      }
    }
  }

  logger << LOG_INFO << "before psi_random_manager.proceeding_in" << endl;
  // check if this works fine !!!
  //  int temp_temp_check_size = temp_check_size;
  psi_random_manager.check_proceeding_in(int_end, temp_check_size, readin);
  //  temp_check_size += (temp_check_size - temp_temp_check_size);
  logger << LOG_INFO << "after psi_random_manager.proceeding_in" << endl;

  temp_check_size += 2;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  int temp_psi_MC_opt_end = atoi(readin[temp_check_size - 2].c_str());
  cout << "# temp_psi_MC_opt_end = " << temp_psi_MC_opt_end << endl;
  int temp_MC_n_channel = atoi(readin[temp_check_size - 1].c_str());
  cout << "# temp_MC_n_channel = " << temp_MC_n_channel << endl;

  if (temp_MC_n_channel != psi_MC_n_channel){logger << LOG_FATAL << "MC_n_channel does not fit." << endl; exit(1);}

  temp_check_size += psi_MC_n_channel;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
  else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  //temp_psi_MC_opt_end ???
  if (temp_psi_MC_opt_end == 0){
    temp_check_size += 1;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

    int temp_n_opt_steps = atoi(readin[temp_check_size - 1].c_str());
    cout << "# temp_n_opt_steps = " << temp_n_opt_steps << endl;

    temp_check_size += 3 * psi_MC_n_channel;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
    else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

    if (temp_check_size != readin.size()){
      temp_check_size += 1;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

      temp_check_size += temp_n_opt_steps * psi_MC_n_channel + 1; // ??? + 1
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_INFO << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endl; return;}
      else{logger << LOG_INFO << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

    }
  }

  logger << LOG_INFO << "Checking expected content of proceeding_in succesfully finished." << endl;

  logger << LOG_INFO << "temp_check_size = " << temp_check_size << " ? " << readin.size() << " = readin.size()" << endl;

  











  //  psi_sran[0] = atof(readin[0].c_str());
  //  psi_sran[1] = atof(readin[1].c_str());
  //  psi_sran[2] = atof(readin[2].c_str());
  for (int i = 0; i < 3; i++){
    psi_sran[i] = hexastr2double(readin[i]);
  }
  h = atoi(readin[3].c_str());
  min = atoi(readin[4].c_str());
  sec = atoi(readin[5].c_str());
  int proc = 6;
  sec_import = sec + 60 * min + 3600 * h;

  logger << LOG_INFO << "Imported runtime: " << h << " h " << min << " min " << sec << " sec   ->   sec_import = " << sec_import << endl;

  psi_i_rej = atol(readin[proc].c_str());
  psi_i_acc = atol(readin[proc + 1].c_str());
  psi_i_nan = atoi(readin[proc + 2].c_str());
  proc += 3;
  full_sum_weight = atof(readin[proc].c_str());
  full_sum_weight2 = atof(readin[proc + 1].c_str());
  proc += 2;

  if (switch_CV){
    for (int c = 0; c < n_qTcut; c++){
      for (int s = 0; s < n_scales_CV; s++){
	full_sum_weight_CV[c][s] = atof(readin[proc + 2 * (c * n_scales_CV + s)].c_str());
	full_sum_weight2_CV[c][s] = atof(readin[proc + 1 + 2 * (c * n_scales_CV + s)].c_str());
      }
    }
    proc += 2 * n_qTcut * n_scales_CV;
  }

  if (n_moments != 0){
    for (int nm = 0; nm < n_moments; nm++){
      full_sum_moment[nm] = atof(readin[proc].c_str());
      full_sum_moment2[nm] = atof(readin[proc + 1].c_str());
      proc += 2;
      if (switch_CV != 0){
	for (int c = 0; c < n_qTcut; c++){
	  for (int s = 0; s < n_scales_CV; s++){
	    full_sum_moment_CV[nm][c][s] = atof(readin[proc + 2 * (c * n_scales_CV + s)].c_str());
	    full_sum_moment2_CV[nm][c][s] = atof(readin[proc + 1 + 2 * (c * n_scales_CV + s)].c_str());
	  }
	}
	proc += 2 * n_qTcut * full_sum_moment_CV[nm][0].size();
      }
    }
  }
  if (switch_distribution != 0){
    int dist_numbers = 3;
    if (switch_CV != 0){dist_numbers += 2 * n_scales_CV;}
    for (int i = 0; i < dat.size(); i++){
      for (int n = 0; n < dat[i].n_bins; n++){
	bin_weight[i][n] = atof(readin[proc + dist_numbers * n].c_str());
	bin_weight2[i][n] = atof(readin[proc + dist_numbers * n + 1].c_str());
	bin_counts[i][n] = atoi(readin[proc + dist_numbers * n + 2].c_str());
	if (switch_CV != 0){
	  for (int s = 0; s < n_scales_CV; s++){
	    bin_weight_CV[s][i][n] = atof(readin[proc + dist_numbers * n + 2 * s + 3].c_str());
	    bin_weight2_CV[s][i][n] = atof(readin[proc + dist_numbers * n + 2 * s + 4].c_str());
	  }
	}
      }
      proc += dist_numbers * dat[i].n_bins;
    }

    for (int i = 0; i < (dddat).size(); i++){
      for (int n = 0; n < (dddat)[i].n_bins; n++){
	bin_weight[dat.size() + i][n] = atof(readin[proc + dist_numbers * n].c_str());
	bin_weight2[dat.size() + i][n] = atof(readin[proc + dist_numbers * n + 1].c_str());
	bin_counts[dat.size() + i][n] = atoi(readin[proc + dist_numbers * n + 2].c_str());
	if (switch_CV != 0){
	  for (int s = 0; s < n_scales_CV; s++){
	    bin_weight_CV[s][dat.size() + i][n] = atof(readin[proc + dist_numbers * n + 2 * s + 3].c_str());
	    bin_weight2_CV[s][dat.size() + i][n] = atof(readin[proc + dist_numbers * n + 2 * s + 4].c_str());
	  }
	}
      }
      proc += dist_numbers * (dddat)[i].n_bins;
    }
  }


  if (switch_TSV){
    logger << LOG_INFO << "# TSV input started" << endl;
    logger << LOG_INFO << "# TSV size start: proc = " << proc << endl;
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  fullsum_weight_TSV[i_s][i_r][i_f] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f)].c_str());
	  fullsum_weight2_TSV[i_s][i_r][i_f] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f) + 1].c_str());
	}
      }
      proc += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      
      if (active_qTcut == 1){
	for (int i_q = 0; i_q < n_qTcut; i_q++){
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      fullsum_weight_qTcut_TSV[i_s][i_q][i_r][i_f] = atof(readin[proc + 2 * (i_q * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s] + i_r * n_scale_fact_TSV[i_s] + i_f)].c_str());
	      fullsum_weight2_qTcut_TSV[i_s][i_q][i_r][i_f] = atof(readin[proc + 2 * (i_q * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s] + i_r * n_scale_fact_TSV[i_s] + i_f) + 1].c_str());
	    }
	  }
	}
	proc += 2 * n_qTcut * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      }
    }
    
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_m = 0; i_m < n_moments; i_m++){
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    fullsum_moment_TSV[i_s][i_m][i_r][i_f] = atof(readin[proc + 2 * (i_m * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s] + i_r * n_scale_fact_TSV[i_s] + i_f)].c_str());
	    fullsum_moment2_TSV[i_s][i_m][i_r][i_f] = atof(readin[proc + 2 * (i_m * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s] + i_r * n_scale_fact_TSV[i_s] + i_f) + 1].c_str());
	  }
	}
      }
      proc += 2 * n_moments * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
    }
    
    logger << LOG_INFO << "no_qTcut_distribution.size() = " << no_qTcut_distribution.size() << endl;

    for (int x_q = 0; x_q < no_qTcut_distribution.size(); x_q++){
      logger << LOG_INFO << "no_qTcut_distribution[" << x_q << "] = " << no_qTcut_distribution[x_q] << "   selection_qTcut_distribution[" << x_q << "] = " << no_qTcut_distribution[x_q] << endl;
    }

    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      //    for (int i_q = 0; i_q < n_qTcut; i_q++){
      logger << LOG_INFO << "no_qTcut_distribution[" << next_no_qTcut << "] = " << no_qTcut_distribution[next_no_qTcut] << endl;
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}
      logger << LOG_INFO << "readin at i_q = " << i_q << "   proc = " << proc << endl;
      for (int i_d = 0; i_d < dat.size(); i_d++){
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  bin_count_TSV[i_q][i_d][i_b] = atoi(readin[proc].c_str());
	  proc++;
	  for (int i_s = 0; i_s < n_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f)].c_str());
		bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f) + 1].c_str());
	      }
	    }
	    proc = proc + 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  bin_count_TSV[i_q][i_ddd][i_b] = atoi(readin[proc].c_str());
	  proc++;
	  for (int i_s = 0; i_s < n_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f)].c_str());
		bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] = atof(readin[proc + 2 * (i_r * n_scale_fact_TSV[i_s] + i_f) + 1].c_str());
	      }
	    }
	    proc = proc + 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	  }
	}
      }
      next_no_qTcut++;
    }
    logger << LOG_INFO << "# TSV size end: proc = " << proc << endl;
    logger << LOG_INFO << "# TSV input finished" << endl;
  }

  psi_tau_opt_end = atoi(readin[proc].c_str());
  logger << LOG_INFO << "# psi_tau_opt_end = " << psi_tau_opt_end << endl;
  proc += 1;
  if (psi_tau_opt_end != -1){
    for (int i = 0; i < psi_n_tau_bins; i++){
      psi_tau_alpha[i] = hexastr2double(readin[proc + i]);
    }
    proc += psi_n_tau_bins;
    psi_tau_beta[0] = psi_tau_alpha[0];
    for (int i = 1; i < psi_tau_beta.size(); i++){psi_tau_beta[i] = psi_tau_beta[i - 1] + psi_tau_alpha[i];}

  }
  if (psi_tau_opt_end == 0){
    for (int i = 0; i < psi_n_tau_bins; i++){
      psi_tau_counts_channel[i] = atoi(readin[proc + 4 * i].c_str());
      psi_tau_cuts_channel[i] = atoi(readin[proc + 4 * i + 1].c_str());
      //      psi_tau_counts_channel[i] = atof(readin[proc + 4 * i].c_str());
      //      psi_tau_cuts_channel[i] = atof(readin[proc + 4 * i + 1].c_str());
      psi_sum_tau_channel_weight[i] = hexastr2double(readin[proc + 4 * i + 2]);
      psi_sum_tau_channel_weight2[i] = hexastr2double(readin[proc + 4 * i + 3]);
      //      psi_sum_tau_channel_weight[i] = atof(readin[proc + 4 * i + 2].c_str());
      //      psi_sum_tau_channel_weight2[i] = atof(readin[proc + 4 * i + 3].c_str());
    }
    proc += 4 * psi_n_tau_bins;
  }
  logger << LOG_INFO << "# TSV tau_opt end: proc = " << proc << endl;

  psi_x1x2_opt_end = atoi(readin[proc].c_str());
  logger << LOG_INFO << "# psi_x1x2_opt_end = " << psi_x1x2_opt_end << endl;
  proc += 1;

  if (psi_x1x2_opt_end != -1){
    for (int i = 0; i < psi_n_x1x2_bins; i++){
      psi_x1x2_alpha[i] = hexastr2double(readin[proc + i]);
      //      psi_x1x2_alpha[i] = atof(readin[proc + 2 * i].c_str());
      //      psi_x1x2_beta[i] = atof(readin[proc + 2 * i + 1].c_str());
    }
    proc += psi_n_x1x2_bins;
    //    proc += 2 * psi_n_x1x2_bins;
    psi_x1x2_beta[0] = psi_x1x2_alpha[0];
    for (int i = 1; i < psi_x1x2_beta.size(); i++){psi_x1x2_beta[i] = psi_x1x2_beta[i - 1] + psi_x1x2_alpha[i];}
  }

  if (psi_x1x2_opt_end == 0){
    for (int i = 0; i < psi_n_x1x2_bins; i++){
      psi_x1x2_counts_channel[i] = atoi(readin[proc + 4 * i].c_str());
      psi_x1x2_cuts_channel[i] = atoi(readin[proc + 4 * i + 1].c_str());
      //      psi_x1x2_counts_channel[i] = atof(readin[proc + 4 * i].c_str());
      //      psi_x1x2_cuts_channel[i] = atof(readin[proc + 4 * i + 1].c_str());
      psi_sum_x1x2_channel_weight[i] = hexastr2double(readin[proc + 4 * i + 2]);
      psi_sum_x1x2_channel_weight2[i] = hexastr2double(readin[proc + 4 * i + 3]);
      //      psi_sum_x1x2_channel_weight[i] = atof(readin[proc + 4 * i + 2].c_str());
      //      psi_sum_x1x2_channel_weight2[i] = atof(readin[proc + 4 * i + 3].c_str());
    }
    proc += 4 * psi_n_x1x2_bins;
  }
  logger << LOG_INFO << "# TSV x1x2_opt end: proc = " << proc << endl;

  psi_z1z2_opt_end = atoi(readin[proc].c_str());
  logger << LOG_INFO << "# psi_z1z2_opt_end = " << psi_z1z2_opt_end << endl;
  proc += 1;

  if (psi_z1z2_opt_end != -1){
    for (int i_z = 1; i_z < 3; i_z++){
      for (int i = 0; i < psi_n_z1z2_bins; i++){
	psi_z1z2_alpha[i_z][i] = hexastr2double(readin[proc + i]);
	//	psi_z1z2_alpha[i_z][i] = atof(readin[proc + 2 * i].c_str());
	//	psi_z1z2_beta[i_z][i] = atof(readin[proc + 2 * i + 1].c_str());
      }
      proc += psi_n_z1z2_bins;
      //      proc += 2 * psi_n_z1z2_bins;

      psi_z1z2_beta[i_z][0] = psi_z1z2_alpha[i_z][0];
      for (int i = 1; i < psi_z1z2_beta[i_z].size(); i++){psi_z1z2_beta[i_z][i] = psi_z1z2_beta[i_z][i - 1] + psi_z1z2_alpha[i_z][i];}

      if (psi_z1z2_opt_end == 0){
	for (int i = 0; i < psi_n_z1z2_bins; i++){
	  psi_z1z2_counts_channel[i_z][i] = atoi(readin[proc + 4 * i].c_str());
	  psi_z1z2_cuts_channel[i_z][i] = atoi(readin[proc + 4 * i + 1].c_str());
	  //	  psi_z1z2_counts_channel[i_z][i] = atof(readin[proc + 4 * i].c_str());
	  //	  psi_z1z2_cuts_channel[i_z][i] = atof(readin[proc + 4 * i + 1].c_str());
	  psi_sum_z1z2_channel_weight[i_z][i] = hexastr2double(readin[proc + 4 * i + 2]);
	  psi_sum_z1z2_channel_weight2[i_z][i] = hexastr2double(readin[proc + 4 * i + 3]);
	  //	  psi_sum_z1z2_channel_weight[i_z][i] = atof(readin[proc + 4 * i + 2].c_str());
	  //	  psi_sum_z1z2_channel_weight2[i_z][i] = atof(readin[proc + 4 * i + 3].c_str());
	}
	proc += 4 * psi_n_z1z2_bins;
      }
    }
  }
  logger << LOG_INFO << "# TSV z1z2_opt end: proc = " << proc << endl;

  psi_random_manager.proceeding_in(proc, readin);
  logger << LOG_INFO << "# TSV random_manager end: proc = " << proc << endl;

  // int_end -> MC_opt_end

  psi_MC_opt_end = atoi(readin[proc].c_str());
  int MC_n_channel = atoi(readin[proc + 1].c_str());
  if (MC_n_channel != psi_MC_n_channel){logger << LOG_FATAL << "MC_n_channel does not fit." << endl; exit(1);}
  proc += 2;
  for (int j = 0; j < psi_MC_n_channel; j++){
    psi_MC_alpha[j] = hexastr2double(readin[proc + j]);
    //    psi_MC_alpha[j] = atof(readin[proc + 2 * j].c_str());
    //    psi_MC_beta[j] = atof(readin[proc + 1 + 2 * j].c_str());
  }
  proc += psi_MC_n_channel;

  psi_MC_beta[0] = psi_MC_alpha[0];
  for (int i = 1; i < psi_MC_beta.size(); i++){psi_MC_beta[i] = psi_MC_beta[i - 1] + psi_MC_alpha[i];}


  //  proc += 2 * psi_MC_n_channel;
  if (psi_MC_opt_end == 0){
    int n_opt_steps = atoi(readin[proc].c_str());
    proc += 1;
    for (int j = 0; j < psi_MC_n_channel; j++){
      psi_counts_channel[j] = atoi(readin[proc + 3 * j].c_str());
      psi_cuts_channel[j] = atoi(readin[proc + 1 + 3 * j].c_str());
      psi_sum_w_channel[j] = hexastr2double(readin[proc + 2 + 3 * j].c_str());
      //      psi_sum_w_channel[j] = atof(readin[proc + 2 + 3 * j].c_str());
    }
    proc += 3 * psi_MC_n_channel;
    if (proc != readin.size()){
      psi_i_alpha_it = atoi(readin[proc].c_str());
      //      psi_i_alpha_it = atof(readin[proc].c_str());
      proc += 1;
      psi_diff_w.resize(n_opt_steps);
      for (int i = 0; i < n_opt_steps; i++){
	psi_diff_w[i] = hexastr2double(readin[proc + i].c_str());
	//	psi_diff_w[i] = atof(readin[proc + i].c_str());
      }
      if (n_opt_steps != 0){
	proc += n_opt_steps;
	psi_alpha_it.resize(n_opt_steps);
	for (int i = 0; i < n_opt_steps; i++){
	  psi_alpha_it[i].resize(psi_MC_n_channel);
	  for (int j = 0; j < psi_MC_n_channel; j++){
	    psi_alpha_it[i][j] = hexastr2double(readin[proc + psi_MC_n_channel * i + j].c_str());
	    //	    psi_alpha_it[i][j] = atof(readin[proc + psi_MC_n_channel * i + j].c_str());
	  }
	}
      }
    }
    proc += n_opt_steps * psi_MC_n_channel + 1;

    logger << LOG_INFO << "end MC optimization" << endl;
  }
  logger << LOG_INFO << "# TSV MC end: proc = " << proc << endl;

  logger << LOG_DEBUG << "finished" << endl;
}


void observable_set::perform_proceeding_out(phasespace_set & psi){
  Logger logger("observable_set::perform_proceeding_out");
  logger << LOG_DEBUG << "started" << endl;

  logger << LOG_DEBUG << "filename_proceeding = " << filename_proceeding << endl;
  ofstream out_proceeding;
  /*
  string test = filename_proceeding + "x";
  cout << "test = " << test << endl;
  out_proceeding.open(test.c_str(), ofstream::out | ofstream::trunc);  
*/
  out_proceeding.open(filename_proceeding.c_str(), ofstream::out | ofstream::trunc);  
  //  out_proceeding.open(filename_proceeding.c_str(), ofstream::out | ofstream::trunc);  
  for (int i = 0; i < 3; i++){
    out_proceeding << double2hexastr(psi_sran[i]) << endl;
    //    out_proceeding << setprecision(25) << psi_sran[i] << endl;
  }
  out_proceeding << h << endl;
  out_proceeding << min << endl;
  out_proceeding << sec << endl;

  out_proceeding << psi_i_rej << endl;
  out_proceeding << psi_i_acc << endl;

  out_proceeding << psi_i_nan << endl;
  out_proceeding << setprecision(18) << full_sum_weight << endl;
  out_proceeding << setprecision(18) << full_sum_weight2 << endl;
  if (switch_CV != 0){
    for (int c = 0; c < n_qTcut; c++){
      for (int s = 0; s < n_scales_CV; s++){
	out_proceeding << setprecision(18) << full_sum_weight_CV[c][s] << endl;
	out_proceeding << setprecision(18) << full_sum_weight2_CV[c][s] << endl;
      }
    }
  }
  if (n_moments != 0){
    for (int nm = 0; nm < n_moments; nm++){
      out_proceeding << setprecision(18) << full_sum_moment[nm] << endl;
      out_proceeding << setprecision(18) << full_sum_moment2[nm] << endl;
      if (switch_CV != 0){
	for (int c = 0; c < n_qTcut; c++){
	  for (int s = 0; s < n_scales_CV; s++){
	    out_proceeding << setprecision(18) << full_sum_moment_CV[nm][c][s] << endl;
	    out_proceeding << setprecision(18) << full_sum_moment2_CV[nm][c][s] << endl;
	  }
	}
      }
    }
  }

  if (switch_distribution != 0){
    for (int i = 0; i < dat.size(); i++){
      for (int n = 0; n < dat[i].n_bins; n++){
	out_proceeding << setprecision(18) << bin_weight[i][n] << endl;
	out_proceeding << setprecision(18) << bin_weight2[i][n] << endl;
	out_proceeding << setprecision(18) << bin_counts[i][n] << endl;
	if (switch_CV != 0){
	  for (int s = 0; s < n_scales_CV; s++){
	    out_proceeding << setprecision(18) << bin_weight_CV[s][i][n] << endl;
	    out_proceeding << setprecision(18) << bin_weight2_CV[s][i][n] << endl;
	  }
	}
      }
    }
    for (int i = 0; i < (dddat).size(); i++){
      for (int n = 0; n < (dddat)[i].n_bins; n++){
	out_proceeding << setprecision(18) << bin_weight[dat.size() + i][n] << endl;
	out_proceeding << setprecision(18) << bin_weight2[dat.size() + i][n] << endl;
	out_proceeding << setprecision(18) << bin_counts[dat.size() + i][n] << endl;
	if (switch_CV != 0){
	  for (int s = 0; s < n_scales_CV; s++){
	    out_proceeding << setprecision(18) << bin_weight_CV[s][dat.size() + i][n] << endl;
	    out_proceeding << setprecision(18) << bin_weight2_CV[s][dat.size() + i][n] << endl;
	  }
	}
      }
    }
  }

  if (switch_TSV){
    out_proceeding << "# TSV output" << endl;
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  out_proceeding << setprecision(18) << fullsum_weight_TSV[i_s][i_r][i_f] << endl;
	  out_proceeding << setprecision(18) << fullsum_weight2_TSV[i_s][i_r][i_f] << endl;
	}
      }
      if (active_qTcut == 1){
	for (int i_q = 0; i_q < n_qTcut; i_q++){
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      out_proceeding << setprecision(18) << fullsum_weight_qTcut_TSV[i_s][i_q][i_r][i_f] << endl;
	      out_proceeding << setprecision(18) << fullsum_weight2_qTcut_TSV[i_s][i_q][i_r][i_f] << endl;
	    }
	  }
	}
      }
    }
    
    for (int i_s = 0; i_s < n_set_TSV; i_s++){
      for (int i_m = 0; i_m < n_moments; i_m++){
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    out_proceeding << setprecision(18) << fullsum_moment_TSV[i_s][i_m][i_r][i_f] << endl;
	    out_proceeding << setprecision(18) << fullsum_moment2_TSV[i_s][i_m][i_r][i_f] << endl;
	  }
	}
      }
    }
    //    for (int i_q = 0; i_q < 1; i_q++){
    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      //    for (int i_q = 0; i_q < n_qTcut; i_q++){
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}

      if (active_qTcut == 0){out_proceeding << "#   no qTcut" << endl;}
      else {out_proceeding << "#   qTcut[" << setw(3) << i_q << "] = " << setw(15) << setprecision(8) << value_qTcut[i_q] << endl;}

      for (int i_d = 0; i_d < dat.size(); i_d++){
	out_proceeding << "#" << char(9) << dat[i_d].xdistribution_name << endl;
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  out_proceeding << bin_count_TSV[i_q][i_d][i_b] << endl;
	  for (int i_s = 0; i_s < n_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		out_proceeding << setprecision(18) << bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] << endl;
		out_proceeding << setprecision(18) << bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] << endl;
	      }
	    }
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	out_proceeding << "#" << char(9) << dddat[i_d].name << endl;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  out_proceeding << bin_count_TSV[i_q][i_ddd][i_b] << endl;
	  for (int i_s = 0; i_s < n_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		out_proceeding << setprecision(18) << bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] << endl;
		out_proceeding << setprecision(18) << bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] << endl;
	      }
	    }
	  }
	}
      }

      next_no_qTcut++;
    }
    
  }
  out_proceeding << "# tau_opt output" << endl;
  out_proceeding << psi_tau_opt_end << endl;
  if (psi_tau_opt_end != -1){
    for (int j = 0; j < psi_tau_alpha.size(); j++){
      out_proceeding << double2hexastr(psi_tau_alpha[j]) << endl;
      //      out_proceeding << setprecision(18) << psi_tau_alpha[j] << endl;
      //      out_proceeding << setprecision(18) << psi_tau_beta[j] << endl;
    }
  }
  if (psi_tau_opt_end == 0){
    for (int j = 0; j < psi_tau_alpha.size(); j++){
      out_proceeding << psi_tau_counts_channel[j] << endl;
      out_proceeding << psi_tau_cuts_channel[j] << endl;
      out_proceeding << double2hexastr(psi_sum_tau_channel_weight[j]) << endl;
      out_proceeding << double2hexastr(psi_sum_tau_channel_weight2[j]) << endl;
      //      out_proceeding << setprecision(18) << psi_tau_counts_channel[j] << endl;
      //      out_proceeding << setprecision(18) << psi_tau_cuts_channel[j] << endl;
      //      out_proceeding << setprecision(18) << psi_sum_tau_channel_weight[j] << endl;
      //      out_proceeding << setprecision(18) << psi_sum_tau_channel_weight2[j] << endl;
    }
  }

  out_proceeding << "# x1x2_opt output" << endl;
  out_proceeding << psi_x1x2_opt_end << endl;
  if (psi_x1x2_opt_end != -1){
    for (int j = 0; j < psi_x1x2_alpha.size(); j++){
      out_proceeding << double2hexastr(psi_x1x2_alpha[j]) << endl;
      //      out_proceeding << setprecision(18) << psi_x1x2_alpha[j] << endl;
      //      out_proceeding << setprecision(18) << psi_x1x2_beta[j] << endl;
    }
  }
  if (psi_x1x2_opt_end == 0){
    for (int j = 0; j < psi_x1x2_alpha.size(); j++){
      out_proceeding << psi_x1x2_counts_channel[j] << endl;
      out_proceeding << psi_x1x2_cuts_channel[j] << endl;
      out_proceeding << double2hexastr(psi_sum_x1x2_channel_weight[j]) << endl;
      out_proceeding << double2hexastr(psi_sum_x1x2_channel_weight2[j]) << endl;
      //      out_proceeding << setprecision(18) << psi_x1x2_counts_channel[j] << endl;
      //      out_proceeding << setprecision(18) << psi_x1x2_cuts_channel[j] << endl;
      //      out_proceeding << setprecision(18) << psi_sum_x1x2_channel_weight[j] << endl;
      //      out_proceeding << setprecision(18) << psi_sum_x1x2_channel_weight2[j] << endl;
    }
  }

  out_proceeding << "# z1z2_opt output" << endl;
  //  cout << "psi_z1z2_opt_end = " << psi_z1z2_opt_end << endl;

  out_proceeding << psi_z1z2_opt_end << endl;

  if (psi_z1z2_opt_end != -1){
    for (int i_z = 1; i_z < 3; i_z++){
      //      if (psi_z1z2_opt_end != -1){
      for (int j = 0; j < psi_z1z2_alpha[i_z].size(); j++){
	out_proceeding << double2hexastr(psi_z1z2_alpha[i_z][j]) << endl;
	//	out_proceeding << setprecision(18) << psi_z1z2_alpha[i_z][j] << endl;
	//	out_proceeding << setprecision(18) << psi_z1z2_beta[i_z][j] << endl;
      }
      if (psi_z1z2_opt_end == 0){
	for (int j = 0; j < psi_z1z2_alpha[i_z].size(); j++){
	  out_proceeding << psi_z1z2_counts_channel[i_z][j] << endl;
	  out_proceeding << psi_z1z2_cuts_channel[i_z][j] << endl;
	  out_proceeding << double2hexastr(psi_sum_z1z2_channel_weight[i_z][j]) << endl;
	  out_proceeding << double2hexastr(psi_sum_z1z2_channel_weight2[i_z][j]) << endl;
	  //	  out_proceeding << setprecision(18) << psi_z1z2_counts_channel[i_z][j] << endl;
	  //	  out_proceeding << setprecision(18) << psi_z1z2_cuts_channel[i_z][j] << endl;
	  //	  out_proceeding << setprecision(18) << psi_sum_z1z2_channel_weight[i_z][j] << endl;
	  //	  out_proceeding << setprecision(18) << psi_sum_z1z2_channel_weight2[i_z][j] << endl;
	}
      }
    }
  }

  out_proceeding << "# random_manager output" << endl;
  psi_random_manager.proceeding_out(out_proceeding);

  out_proceeding << "# MC_opt output" << endl;
  out_proceeding << psi_MC_opt_end << endl;
  out_proceeding << psi_MC_alpha.size() << endl;
  for (int j = 0; j < psi_MC_alpha.size(); j++){
    out_proceeding << double2hexastr(psi_MC_alpha[j]) << endl;
    //    out_proceeding << setprecision(18) << psi_MC_alpha[j] << endl;
    //    out_proceeding << setprecision(18) << psi_MC_beta[j] << endl;
  }
  if (psi_MC_opt_end == 0){
    int n_opt_steps = psi_alpha_it.size();
    out_proceeding << n_opt_steps << endl;
    for (int j = 0; j < psi_MC_alpha.size(); j++){
      out_proceeding << psi_counts_channel[j] << endl;
      out_proceeding << psi_cuts_channel[j] << endl;
      out_proceeding << double2hexastr(psi_sum_w_channel[j]) << endl;
      //      out_proceeding << setprecision(18) << psi_sum_w_channel[j] << endl;
    }
    out_proceeding << setprecision(18) << psi_i_alpha_it << endl;
    for (int i = 0; i < n_opt_steps; i++){
      out_proceeding << double2hexastr(psi_diff_w[i]) << endl;
      //      out_proceeding << psi_diff_w[i] << endl;
    }
    for (int i = 0; i < n_opt_steps; i++){
      for (int j = 0; j < psi_MC_alpha.size(); j++){
	out_proceeding << double2hexastr(psi_alpha_it[i][j]) << endl;
	//	out_proceeding << setprecision(18) << psi_alpha_it[i][j] << endl;
      }
    }
    out_proceeding << "weight optimization not yet finished!" << endl;
  }
  out_proceeding.close();

  logger << LOG_DEBUG << "finished" << endl;
}


void observable_set::perform_proceeding_check(phasespace_set & psi){
  Logger logger("observable_set::perform_proceeding_check");
  logger << LOG_DEBUG << "started" << endl;

  double Xsection_delta = sqrt((full_sum_weight2 - pow(full_sum_weight, 2) / psi_i_gen)) / (psi_i_gen - 1);
  double Xsection = full_sum_weight / psi_i_gen;
  double weights2_NLO_LO = abs(Xsection_delta / sigma_normalization);

  logger << LOG_INFO << "Xsection_delta = " << Xsection_delta << endl;
  logger << LOG_INFO << "Xsection = " << Xsection << endl;
  logger << LOG_INFO << "weights2_NLO_LO = " << weights2_NLO_LO << endl;
  logger << LOG_INFO << "sigma_LO = " << sigma_normalization << endl;
  logger << LOG_INFO << "n_events_max = " << psi_n_events_max << endl;
  logger << LOG_INFO << "n_step = " << psi_n_step << endl;

  ///  cout << "jets[1] = " << jets[1] << endl;
  ///  cout << "sigma_LO_deviation = " << sigma_normalization_deviation << endl;
  ///  cout << "(jets[1] >= n_events_max - n_step) = " << (jets[1] >= psi_n_events_max - psi_n_step) << endl;
  ///  cout << "(jets[1] >= n_events_min && weights2_NLO_LO < sigma_LO_deviation) = " << (jets[1] >= psi_n_events_min && weights2_NLO_LO < sigma_normalization_deviation) << endl;

  ///  if ((jets[1] >= psi_n_events_max - psi_n_step) || 
  ///      (jets[1] >= psi_n_events_min && weights2_NLO_LO < sigma_normalization_deviation)){int_end = 1;}
  logger << LOG_INFO << "psi_i_acc = " << psi_i_acc << endl;
  logger << LOG_INFO << "sigma_LO_deviation = " << sigma_normalization_deviation << endl;
  logger << LOG_INFO << "switch_output_proceeding = " << switch_output_proceeding << endl;
  logger << LOG_INFO << "(psi_i_acc >= n_events_max) = " << (psi_i_acc >= psi_n_events_max) << endl;
  logger << LOG_INFO << "(psi_i_acc >= n_events_max - n_step) = " << (psi_i_acc >= psi_n_events_max - psi_n_step) << endl;
  logger << LOG_INFO << "(psi_i_acc >= n_events_min && weights2_NLO_LO < sigma_LO_deviation) = " << (psi_i_acc >= psi_n_events_min && weights2_NLO_LO < sigma_normalization_deviation) << endl;

  if (((psi_i_acc >= psi_n_events_max) && switch_output_proceeding == 1) || 
      ((psi_i_acc >= psi_n_events_max - psi_n_step) && switch_output_proceeding == 2) || 
      ((psi_i_acc >= psi_n_events_min) && (weights2_NLO_LO < sigma_normalization_deviation) && (psi_switch_n_events_opt != 2))){int_end = 1;}
      else{
	//      out_integration << "******************************************************* resumption ******************************************************" << endl;
  }

  logger << LOG_DEBUG << "finished" << endl;
}
