#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../include/definitions.observable.set.cxx"
void munich::integration_born(){
  static Logger logger("munich::integration_born");
  logger << LOG_INFO << "called" << endl;

  psi.initialization_phasespace_born();

  generic.determination_subprocess_psp(0, psi);
  generic.combination_subprocess_psp(0, psi, osi);

  osi.perform_selection_content_pdf(); // strange position - shift ???

  generic.ax_psp_psp(0, psi);
  psi_MC_n_channel = generic.determination_MCchannels_psp(0, psi);

  psi.initialization_mapping_parameter(isi);
  psi.initialization_minimum_tau(isi);
  psi.initialization_minimum_phasespacecut(isi);
  psi.initialization_optimization(isi);
  psi.initialization_filename(isi);

  // generation of optimized xbs limits (including invariant-mass cuts)
  psi.initialization_phasespace_subprocess();
  generic.optimize_minv_psp(psi);
  psi.initialization_phasespace_subprocess_optimization();

  // generation of MC_tau mappings
  generic.ac_tau_psp_psp(0, psi_tau_MC_map, psi);
  if (csi.type_contribution == "RT"){initialization_fake_dipole_mapping_RT(psi, generic);}
  if (csi.type_contribution == "L2RT"){initialization_fake_dipole_mapping_RT(psi, generic);}
  psi.initialization_phasespace_MC_tau();

  psi.initialization_phasespace_IS();
  psi.initialization_MC();

  osi.initialization_contribution(csi); // only in born integration ???
  osi.initialization_tree();

  osi.initialization_TSV();
  osi.initialization_CV();
  osi.initialization_runtime_partonlevel();
  osi.initialization_distribution();
  osi.initialization_integration(psi);

  observable_set save_osi = osi;
  phasespace_set save_psi = psi;
  runresumption_set rsi(osi, psi, save_osi, save_psi);

  osi.initialization_LHAPDF();
  osi.initialization_OpenLoops_process(psi);
  generic.phasespacepoint_psp(osi);
  osi.calculate_ME2check_born();

  osi.output_check_running_alpha_S();
  //  integrate_topwidth(osi, psi);

  if (psi_n_events_max == 0){osi.int_end = 1;}
  if (osi.user.int_value[osi.user.int_map["rescaling_exponent"]] != 0){psi_hcf = psi_hcf * pow(osi.user.double_value[osi.user.double_map["rescaling_factor"]], osi.user.int_value[osi.user.int_map["rescaling_exponent"]]);}

  if (osi.int_end){osi.output_zero_contribution_complete(psi);}
  osi.initialization_runtime();
  while (osi.int_end == 0){
    psi.calculate_IS();
    generic.ac_psp_psp(0, psi_MC_channel, psi);
    osi.determine_p_parton(psi);
    if (osi.p_parton != osi.p_parton){errorhandling_c_psp(); continue;}
    perform_event_selection(osi, generic);
    if (osi.cut_ps[0] == -1){psi.handling_cut_psp(); continue;}
    if (osi.switch_console_output_tau_0){psi.output_check_tau_0();}
    if (osi.switch_output_testpoint){osi.output_testpoint(psi);}
    if (psi_i_acc == psi_n_events_max){osi.int_end = 1;}
    generic.ag_psp_psp(0, 0, psi);
    psi.calculate_g_tot();
    if (std::isnan(psi_g_tot) || std::isinf(psi_g_tot)){errorhandling_gtot(); continue;} // isinf case ???
    osi.calculate_ME2_born();
    if (std::isnan(osi.ME2)){errorhandling_me2(); continue;}
    if (!(osi.check_vanishing_ME2_end) && csi.type_contribution == "born"){handling_vanishing_me2(); if (osi.flag_vanishing_ME2){continue;}}

    generic.calculate_dynamic_scale(0, osi);
    generic.calculate_dynamic_scale_TSV(0, osi);
    osi.determine_scale();

    if (osi.switch_moment){generic.moments(osi);}

    osi.calculate_pdf_LHAPDF_CV();
    //    calculate_pdf_LHAPDF_CV(osi);
    osi.calculate_pdf_LHAPDF_TSV();
    //    calculate_pdf_LHAPDF_TSV(osi);

    //    if (osi.pdf_factor[0] != osi.pdf_factor[0]){errorhandling_me2(); continue;}
    //    if (osi.var_rel_alpha_S != osi.var_rel_alpha_S){errorhandling_me2(); continue;}
    if (std::isnan(osi.pdf_factor[0])){errorhandling_pdf(); continue;}
    if (std::isnan(osi.var_rel_alpha_S)){errorhandling_alpha_S(); continue;}

    osi.determine_integrand(psi);
    osi.determine_psp_weight_TSV(psi);
    osi.determine_psp_weight();
    if (osi.switch_output_maxevent){osi.output_integrand_maximum(psi);}

    if (osi.switch_distribution){determine_distribution_complete(osi);}

    static double optimization_modifier = 1.;
    if (osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]){
      optimization_modifier = pow(osi.particle_event[osi.access_object["Vrec"]][0][0].pT, osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]);
      logger << LOG_DEBUG << "optimization_modifier = " << optimization_modifier << endl;
    }   

    psi.psp_MCweight_optimization(osi.integrand, osi.this_psp_weight, osi.this_psp_weight2, optimization_modifier);
    psi_i_acc++;
    if (psi_i_acc % psi_n_step == 0){rsi.perform_iteration_step();}
    /*
    if (psi_i_acc > psi_n_events_max){// never happens -> just to avoid compilation error...
      output_weight_optimization(psi, osi, rsi.size_proc_generic, rsi.size_proceeding);
    }
    */
    osi.determine_runtime(psi);
  }
  osi.output_finalization_integration(psi);
}
