#ifndef SUMMARY_SUBPROCESS_H
#define SUMMARY_SUBPROCESS_H

class summary_generic;
class summary_contribution;

class summary_subprocess {
private:

public:

  ////////////////////
  //  constructors  //
  ////////////////////

  summary_subprocess();
  summary_subprocess(string _name, summary_contribution & _contribution);
  summary_subprocess(string _name, int _n_seed, int _default_size_CV, summary_contribution & _contribution);

  ///////////////////////
  //  access elements  //
  ///////////////////////

  // each 'summary_subprocess' belongs to a specific 'summary_contribution'
  summary_contribution *ycontribution;
  // only one 'summary_generic'
  summary_generic *ygeneric;
  // only one 'observable_set'
  observable_set *osi;

  string name;
  int n_seed;
  int default_size_CV;

  double error2_time;
  double time_per_event;
  double used_runtime;
  long long used_n_event;

  double extrapolated_runtime;
  double extrapolated_n_event;
  double extrapolated_sigma_deviation;
  double extrapolated_sigma_normalization;
  double extrapolated_sigma_normalization_deviation;

  int max_number_of_jobs_for_one_channel;
  /*
  // always identical to respective contribution
  int average_factor;

  int active_qTcut;
  int output_n_qTcut;
  int selection_n_qTcut;
  */

  vector<double> result_run;
  vector<double> deviation_run;

  //  vector<int> remove_run;
  vector<vector<int> > remove_run_qTcut;
  vector<vector<int> > remove_run_qTcut_TSV;
  vector<vector<int> > remove_run_qTcut_CV;

  vector<double> error2_time_run;
  vector<double> time_per_event_run;
  vector<double> used_runtime_run;
  vector<long long> used_n_event_run;


  long long no_results;

  // only for reference result !!!
  vector<long long> N;
  long long N_all;


  double result;
  double deviation;
  double chi2;

  double Nd_event_CV;
  long long N_event_CV;
  vector<long long> N_valid_event_CV;
  // 1st: qTcut
  vector<vector<double> > result_CV;
  vector<vector<double> > deviation_CV;
  vector<vector<double> > chi2_CV;

 //  check meaning of n_parallel_runs_CV and related ones !!!
  vector<int> n_parallel_runs_reference_CV;
  vector<int> n_valid_parallel_runs_reference_CV;
  vector<vector<int> > n_parallel_runs_CV;
  vector<vector<int> > n_valid_parallel_runs_CV;

  vector<long long> N_event_run_CV;
  vector<vector<vector<double> > > result_run_CV;
  vector<vector<vector<double> > > deviation_run_CV;



  //  long long no_results_TSV;

  double Nd_event_TSV;
  long long N_event_TSV;
  vector<long long> N_valid_event_TSV;
  // 1st: qTcut
  vector<vector<vector<vector<vector<double> > > > > result_TSV;
  vector<vector<vector<vector<vector<double> > > > > deviation_TSV;
  vector<vector<vector<vector<vector<double> > > > > chi2_TSV;
  //  check meaning of n_parallel_runs_TSV !!!
  vector<int> n_parallel_runs_reference_TSV;
  vector<int> n_valid_parallel_runs_reference_TSV;
  vector<vector<vector<vector<vector<int> > > > > n_parallel_runs_TSV;
  vector<vector<vector<vector<vector<int> > > > > n_valid_parallel_runs_TSV;

  vector<long long> N_event_run_TSV;
  vector<vector<vector<vector<vector<vector<double> > > > > > result_run_TSV;
  vector<vector<vector<vector<vector<vector<double> > > > > > deviation_run_TSV;





  vector<long long> distribution_N_CV;
  vector<vector<long long> > distribution_N_binwise_CV;
  vector<vector<vector<double> > > distribution_result_CV;
  vector<vector<vector<double> > > distribution_deviation_CV;
  vector<vector<vector<double> > > distribution_chi2_CV;

  vector<vector<long long> > distribution_run_N_CV;
  vector<vector<vector<long long> > > distribution_run_N_binwise_CV;
  vector<vector<vector<vector<double> > > > distribution_run_result_CV;
  vector<vector<vector<vector<double> > > > distribution_run_deviation_CV;

  // questionable if useful !!!
  vector<vector<long long> > distribution_N_combination_CV;
  vector<vector<vector<long long> > > distribution_N_bin_combination_CV;

  vector<vector<long long> > all_distribution_N_binwise_CV;
  vector<vector<vector<long long> > > combination_all_distribution_N_binwise_CV;

  vector<vector<int> > counter_remove_distribution_run_CV;
  vector<vector<int> > counter_nonzero_distribution_run_CV;

  //  vector<vector<vector<vector<double> > > > distribution_run_deltasigma;
  //  vector<vector<vector<vector<double> > > > distribution_run_weight;
  


  //  vector<long long> N_TSV;

  long long distribution_N_TSV;
  vector<vector<vector<vector<vector<vector<long long> > > > > > distribution_N_binwise_TSV;
  vector<vector<vector<vector<vector<vector<double> > > > > > distribution_result_TSV;
  vector<vector<vector<vector<vector<vector<double> > > > > > distribution_deviation_TSV;
  vector<vector<vector<vector<vector<vector<double> > > > > > distribution_chi2_TSV;
  
  vector<long long> distribution_run_N_TSV;
  vector<vector<vector<vector<vector<vector<vector<long long> > > > > > > distribution_run_N_binwise_TSV;
  vector<vector<vector<vector<vector<vector<vector<double> > > > > > > distribution_run_result_TSV;
  vector<vector<vector<vector<vector<vector<vector<double> > > > > > > distribution_run_deviation_TSV;


  // questionable if useful (in particular the ones without qTcut) !!!
  vector<vector<long long> > distribution_N_combination_TSV;
  vector<vector<vector<long long> > > distribution_N_bin_combination_TSV;
  vector<vector<vector<vector<long long> > > > distribution_N_bin_combination_qTcut_TSV;
  vector<vector<vector<long long> > > distribution_N_combination_qTcut_TSV;

  vector<vector<long long> > all_distribution_N_binwise_TSV;
  vector<vector<vector<long long> > > combination_all_distribution_N_binwise_TSV;

  vector<vector<vector<int> > > counter_remove_distribution_run_qTcut_TSV;
  vector<vector<vector<int> > > counter_nonzero_distribution_run_qTcut_TSV;




  // only temporary meaning ???
  vector<vector<int> > switch_off_run;

  // only temporary meaning ???
  long long combination_N_event_all;
  vector<long long> combination_N_tot;
  vector<long long> combination_N_bin;
  vector<long long> combination_N_bin_min;
  vector<double> combination_fraction;
  vector<double> combination_result;
  vector<double> combination_deviation;
	
  vector<int> remove_run_bin;

  // only temporary meaning ???
  double result_subprocess;
  double deviation_subprocess;
  long long N_subprocess;
  long long temp_N_binwise;

  vector<vector<int> > type_parton;




  ///////////////
  //  methods  //
  ///////////////

  void readin_runtime(string & result_moment);

  void readin_result_CV(string & result_moment);
  void combination_result_CV(string & result_moment);
  void removal_exceptional_runs_result_CV();

  void combine_result_original();
  void combine_result_alternative();

  void combine_result_original_CV();
  void combine_result_alternative_CV();
  void combine_result_hybrid_CV();

  void readin_result_TSV(string & result_moment);
  void combination_result_TSV(string & result_moment);
  void removal_exceptional_runs_result_TSV();

  void combine_result_original_TSV();
  void combine_result_alternative_TSV();
  void combine_result_hybrid_TSV();

  void readin_distribution_CV();
  void combination_distribution_CV();
  void combine_distribution_hybrid_CV(int x_z, int i_d, int i_b, int i_s);
  void combine_distribution_conservative_CV(int x_z, int i_d, int i_b, int i_s);

  void combine_distribution_original_CV();

  void readin_distribution_TSV();
  void combination_distribution_TSV();
  void combine_distribution_hybrid_TSV(int x_z, int x_q, int i_d, int i_b, int i_s, int i_r, int i_f);
  void combine_distribution_conservative_TSV(int x_z, int x_q, int i_d, int i_b, int i_s, int i_r, int i_f);
  void combine_distribution_aggressive_TSV(int x_z, int x_q, int i_d, int i_b, int i_s, int i_r, int i_f);
 
};
#endif
