      function lowint(r,wgt)
      implicit none
      include 'types.f'
      real(dp):: lowint
      
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'npart.f'
      include 'vegas_common.f'
      include 'sprods_com.f'
      include 'facscale.f'
      include 'kprocess.f'
      include 'energy.f'
      include 'x1x2.f'
      include 'nproc.f'
      include 'nprocesses.f'
      include 'hdecaymode.f'

c-----------------------------------------------------------------------
      real(dp):: flux
      real(dp):: wgt,msqB(-nf:nf,-nf:nf),msqV1(-nf:nf,-nf:nf)
      real(dp):: msqV2(-nf:nf,-nf:nf)
      real(dp):: fx1(-nf:nf),fx2(-nf:nf),p(mxpart,4),r(mxdim)
      real(dp):: pswt
      real(dp):: shower_wgt, obs
      real(dp):: new_muf,new_mur
      
      integer:: ih1,ih2,j,k,nvec
      logical bin,dryrun
      common/density/ih1,ih2
      common/bin/bin ! this is useful for filling the histogram

      logical:: outside_cuts

      
      lowint=0._dp
      p(:,:)=0._dp

c----------> generate phase-space point:
      pswt=zip
      if(nproc==nDY)then
         npart=2
         call gen2(r,p,pswt,*999)
      elseif(nproc==nDYMY)then
         npart=2
         call gen2ymfixed(r,p,pswt,*999)
      elseif (nproc==nWp)then
         npart=2
         call gen2(r,p,pswt,*999)
      elseif (nproc==nWm)then
         npart=2
         call gen2(r,p,pswt,*999)
      elseif(nproc==nH)then
         if(hdecaymode == 'none') then
            npart=2        
            call gen2(r,p,pswt,*999)
         elseif (hdecaymode == 'ZZee' .or. hdecaymode == 'ZZmm' ) then
            npart=4        
            call gen4h(r,p,pswt,*999)
         elseif (hdecaymode == 'ZZem') then
            npart=4      
            call gen4h(r,p,pswt,*999)
         else
            npart=2        
            call gen2m(r,p,pswt,*999)
         endif
      else
         call unimplemented_process
      endif
      
c----------> check physical cuts:
      if( outside_cuts(p) ) goto 999
      
c----------> s(ij):
      nvec=npart+2
      call dotem(nvec,p,s)

c---------->update scales in case of dynamical scales (dummy call if dynamical scales are off)
      call update_scales_and_alphas(p,new_muf,new_mur)

c----------> call matrix elements:
      if( nproc==nDY )then
         msqB=0d0
         call qqb_z(p,msqB)
         msqV1=0d0
         msqV2=0d0
         call qqb_z_v(p,msqB,msqV1,msqV2)
      elseif( nproc==nDYMY )then
         msqB=0d0
         call qqb_z(p,msqB)
         msqV1=0d0
         msqV2=0d0
         call qqb_z_v(p,msqB,msqV1,msqV2)
      elseif( nproc==nWp )then
         msqB=0d0
         call qqb_w(p,msqB)
         msqV1=0d0
         msqV2=0d0
         call qqb_w_v(p,msqB,msqV1,msqV2)
      elseif( nproc==nWm )then
         msqB=0d0
         call qqb_w(p,msqB)
         msqV1=0d0
         msqV2=0d0
         call qqb_w_v(p,msqB,msqV1,msqV2)
      elseif( nproc==nH ) then
         msqB=0d0
         msqV1=0d0
         msqV2=0d0
         if (hdecaymode(1:2)=='ZZ') then 
            call hzzexact(p,msqB)
            !LR virtual corrections should work out of the box
            !but check if there is something more subtle to be changed
            call gg_h_v(p,msqB,msqV1,msqV2)
         else
            call gg_h(p,msqB)
            call gg_h_v(p,msqB,msqV1,msqV2)
         endif
      endif

c----------> calculate flux:
      xx(1)=-2._dp*p(1,4)/sqrts
      xx(2)=-2._dp*p(2,4)/sqrts
      flux=fbGeV2/(2._dp * xx(1) * xx(2) * sqrts**2)
      
c---------->
      lowint=flux*pswt

c----------> shower:
!----: for quick run without resummation: dryrun=true
      call shower(p,msqB,msqV1,msqV2,lowint*wgt,shower_wgt,dryrun)
      
      if(dryrun .or. (.not.bin))then
         facscale= new_muf
         call fdist(ih1,xx(1),facscale,fx1)
         call fdist(ih2,xx(2),facscale,fx2)
         shower_wgt = 0d0
         do j=-nf,nf
            do k=-nf,nf    
               shower_wgt = shower_wgt + fx1(j)*fx2(k)*msqB(j,k)
               continue
            enddo
         enddo
      endif
      lowint=lowint*shower_wgt !LR: fbarns

      return

 999  continue
      lowint=0._dp
      
      return
      end


