module seeds
  use types; use consts_dp; use random_dists
  use warnings_and_errors 
  implicit none 
  private 
  
  public :: setseeds
  
contains
  
  subroutine setseeds(iseq,rndiseq)
    logical, intent(in) :: rndiseq
    integer, intent(in) :: iseq
     ! ------------------
    integer    :: time_array(8)
    real(dp)   :: rseed(3)  
    if (rndiseq .and. iseq >= 0) call wae_error('setseeds','Decide &
         &whether you want random seeds or if you want to fix them &
         &to particular values? Cannot do both at the same time') 

    if (rndiseq) then 
       call date_and_time(values=time_array)
       ! time in this day/10: max number: 86400000/100
       rseed(1) = (((60._dp*time_array(5)+time_array(6))+time_array(7))&
            &*1000._dp+time_array(8))
       rseed(2) = 0._dp 
       rseed(3) = 0._dp  
       call rangen(0,rseed)
    elseif (iseq >=0) then 
       rseed(1) = iseq 
       rseed(2) = 0._dp 
       rseed(3) = 0._dp 
       call rangen(0,rseed)
    else
    end if

  end subroutine setseeds
  



end module seeds
