This folder contains two examples of input card.

The input card NNLOJET_H125_heft.yml can be used to generate predictions at to NLO+NNLL for the transverse momentum spectrum of the Higgs boson at LHC 13 TeV. The fixed-order predictions at this accuracy are curtesy of the NNLOJET collaboration.

To execute the program, please type

```bash
../python/radish.py -i NNLOJET_H125_heft.yml -n 5
```

and you should have your results in a few minutes running on 5 cores. By default the order of accuracy is NLO+NNLL. The fixed order accuracy can be LO, NLO, or NNLO, and the resummed accuracy can be NLL, NNLL or N$^3$LL. You can change the accuracy in the input card as you please. You might need to increase the statistics (by a factor of 10 or so) to obtain more precise results at N$^3$LL.

You can also plot the resulting predictions by typing

```bash
../python/radish_plotter.py -i NNLOJET_H125_heft.yml
```

which will produce a plot in the output folder `NNLOJET_H125_heft`.

The input card MCFM_H125_heft_joint.yml can be used to generate predictions at to NLO+NNLL for the transverse momentum spectrum of the Higgs boson at LHC 13 TeV in the presence of a jet veto of 30 GeV on the hardest jet. The fixed-order predictions at this accuracy have been produced with MCFM.

To execute the program, please type

```bash
../python/radish.py -i MCFM_H125_heft_joint.yml -n 9
```

and you should have your results in a few minutes running on 9 cores. By default the order of accuracy is NLO+NNLL. The fixed order accuracy can be LO, NLO and the resummed accuracy can be NLL or NNLL. You can change the accuracy in the input card as you please.

You can also plot the resulting predictions by typing

```bash
../python/radish_plotter.py -i MCFM_H125_heft_joint.yml
```

which will produce a plot in the output folder `MCFM_H125_heft_joint`.

